<?php
// +----------------------------------------------------------------+
// | atmail.php														|
// +----------------------------------------------------------------+
// | Function: Create a user, auth, and open the selected login 	|
// | style.															|
// +----------------------------------------------------------------+
// | Source-code (C) CalaCode.com 1998-2005 . All rights reserved	|
// | See http://calacode.com/license.ehtml for license agreement	|
// +----------------------------------------------------------------+
// | Date: January 2005												|
// +----------------------------------------------------------------+

require_once('header.php');
require_once('Global.php');

// Check for account sent as one string
if (isset($_REQUEST['account'])) {
	list($_REQUEST['username'], $_REQUEST['pop3host']) = explode('@', $_REQUEST['account']);
}

// sanitize some vars
if (isset($_REQUEST['username'])) {
	$_REQUEST['username'] = htmlspecialchars($_REQUEST['username']);
}

if (isset($_REQUEST['pop3host'])) {
	$_REQUEST['pop3host'] = htmlspecialchars($_REQUEST['pop3host']);
}

// Detect Hostname, so that the hostname remains set properly on logout, etc.
$var['Hostname'] = $_SERVER['HTTP_HOST'];
// Find the current hostname and take away and www. extension , just leave the domain
if (preg_match("/^www\./i", $_SERVER['HTTP_HOST']))
        $var['Hostname'] = preg_replace('/^www\./i', '', $_SERVER['HTTP_HOST']);
// If starting with 'mail' remove the 'mail' part to find current domain
if (preg_match("/^mail\./i", $_SERVER['HTTP_HOST']))
        $var['Hostname'] = preg_replace('/^mail\./i', '', $_SERVER['HTTP_HOST']);
// If starting with 'webmail' remove the 'webmail' part to find current domain
if (preg_match("/^webmail\./i", $_SERVER['HTTP_HOST']))
        $var['Hostname'] = preg_replace('/^webmail\./i', '', $_SERVER['HTTP_HOST']);

$var = array();

$atmail = new AtmailGlobal();

$atmail->getAuthObj(false);
$atmail->auth();

// Only start session if user is authentcated
require_once('Session.php');

// Set Session ID based on account and some random text
/*$rand = '';
while (strlen($rand) < 30)
	$rand .= chr(mt_rand(32, 126));

$sessID = md5($_REQUEST['username'].$_REQUEST['pop3host'].$_SERVER['$rand);
session_id($sessID);
*/
session_start();

$atmail->auth->update_session();
$_SESSION['auth'] =& $atmail->auth;


// Optional data for the "Remember me" section!
if (isset($_REQUEST['RememberMe']))
{
	if (isset($_REQUEST['LoginType']))
	   $cookie['LoginType'] = $_REQUEST['LoginType'];

	if (isset($_REQUEST['Language']))
	   $cookie['Language'] = $_REQUEST['Language'];

	if(isset($_REQUEST['NewWindow']))
	   $cookie['NewWindow'] = $_REQUEST['NewWindow'];

	if (isset($_REQUEST['MailServer']))
	   $cookie['MailServer'] = $_REQUEST['MailServer'];

	if (isset($domains[$_REQUEST['pop3host']]))
		$cookie['MailType'] = 'file';
	else
		$cookie['MailType'] = $_REQUEST['MailType'];

	$cookie['username'] = $_REQUEST['username'];
	$cookie['pop3host'] = $_REQUEST['pop3host'];

	$value = '';

    // Create cookie value with sanitized input
	foreach ($cookie as $k=>$v)
		$value .= "$k&" . strip_tags($v) .'&';

	$time = strtotime('+14 days');
	setcookie('atmailuser', $value, $time, '/');
}
elseif (isset($_COOKIE['atmailuser']) && strlen($_COOKIE['atmailuser']) > 0)
{
	// Delete the remember-me cookie if a remembered account logs in with 
	// 'Remember Me' un-checked
	preg_match('/username&(.+?)&pop3host&(.+?)&/', $_COOKIE['atmailuser'], $m);
	if ($_REQUEST['username'] == $m[1] && $_REQUEST['pop3host'] == $m[2]) {
		setcookie('atmailuser', '', strtotime('-14 days'), '/');
	}
	
	//setcookie('atmailuser', '', strtotime('+14 days'), '/');
}


$var['logintype'] = $_REQUEST['LoginType'];

// If using the Advanced interface, switch the template to XUL for FF
if (strpos(strtolower($_SERVER['HTTP_USER_AGENT']), 'gecko') !== false && $var['logintype'] == 'xp')
$var['logintype'] = 'xul';

$lang = $atmail->logintype();
$atmail->loadprefs();

// Toggle which MailType to use. IMAP or POP3
//if ( !$domains[$atmail->pop3host])
	$atmail->mailtype();

$atmail->Language = ($lang)? $lang : $_REQUEST['Language'];
if (!$atmail->Language)
	$atmail->Language = $pref['Language'];

//$pref['opensource'] = 1;

if ($pref['opensource'])
{
	echo $atmail->FromField;
	$atmail->end();
}


$var['mailtype'] = $atmail->print_mailtypes();
$var['mailtype'] = str_replace("option value=\"{$var['logintype']}\" ", "option value=\"{$var['logintype']}\" selected", $var['mailtype']);

if ($pref['welcome_msg'] && $_REQUEST['NewUser'])
{
    require_once('SendMsg.php');

    // Build the message to send
    $sendmsg = new SendMsg(array(
      'Account'      => "$atmail->username@$atmail->pop3host",
      'EmailTo'      => "$atmail->username@$atmail->pop3host",
      'EmailFrom'   => "$atmail->username@$atmail->pop3host",
      'EmailSubject' => "Welcome to your new Account",
      'ContentType'  => "text/html",
      'EmailMessage' => $atmail->parse($pref['welcome_msg'], array('Account' => "$atmail->username@$atmail->pop3host", 'FirstName' => $atmail->param('FirstName'))),
      'EmailBox'  => "Inbox",
      'EmailUIDL' => time() . getmypid()));

    $sendmsg->buildmsg();
	$sendmsg->deliver(false);
}

$var['unique'] = getmypid() . time();

// Change the users color settings, if logging into the XP interface
if ($var['logintype'] == 'xp'  || $var['logintype'] == 'xul')
{
    $atmail->changecolor(array(
      'PrimaryColor'   => "#EBE9E4",
      'SecondaryColor' => "#F4F4F4",
      'ThirdColor'     => "#FAFAFA",
      'HeaderColor'    => "#F5F5F5",
      'HeadColor'      => "#06082C",
      'BgColor'        => "#F9F9F9",
      'TextColor'      => "#06082C",
      'TextHeadColor'  => "#303030",
      'LinkColor'      => "#000000",
      'VlinkColor'     => "#000033",
      'OnColor'        => "#F3F3F3",
      'OffColor'       => "#FFFFFF",
      'SelectColor'    => "#E4EEF8",
      'TopBg'          => "imgs/graygrad.gif")
    );

}
elseif( $var['logintype'] == 'simple' || $var['logintype'] == 'ajax')
{
    $atmail->changecolor(array(
      'PrimaryColor'   => "#EBE9E4",
      'SecondaryColor' => "#F8FBFD",
      'ThirdColor'     => "#FAFAFA",
      'HeaderColor'    => "#F5F5F5",
      'HeadColor'      => "#06082C",
      'BgColor'        => "#F9F9F9",
      'TextColor'      => "#06082C",
      'TextHeadColor'  => "#303030",
      'LinkColor'      => "#000000",
      'VlinkColor'     => "#000033",
      'OnColor'        => "#F3F3F3",
      'OffColor'       => "#FFFFFF",
      'SelectColor'    => "#FAF7F7",
      'TopBg'          => "imgs/graygrad.gif")
    );

}

// Decide which screen to display on the login ( for the professional interface )
if ($atmail->StartPage)
    $var['startpage'] = "html/$atmail->Language/{$var['logintype']}/emailframe.html";
else
    $var['startpage'] = "html/$atmail->Language/{$var['logintype']}/startframe.html";

// Print the users login screen
if( $var['logintype'] == 'ajax')
{
	$var['atmailstyle'] = $atmail->parse("html/$atmail->Language/simple/atmailstyle.css" );
	$var['mailstyle'] = $atmail->parse("html/$atmail->Language/simple/atmailstyle-mail.css");

	// Print the simple interface template
	$var['Ajax'] = 1;

	$result =  $atmail->parse("html/$atmail->Language/simple/showmail_interface.html", $var);

	// insert default values for Received After selects
	$after_date = strtotime("-61 days",time());
	$after_day = date("d", $after_date);
	$after_month = date("m", $after_date);
	$after_year = date("y", $after_date);
	$result = preg_replace("/(<select id=\"SearchAfterDay\".*)<option value=\"$after_day\"/", "\$1<option value=\"$after_day\" selected", $result);
	$result = preg_replace("/(<select id=\"SearchAfterMonth\".*)<option value=\"$after_month\"/", "\$1<option value=\"$after_month\" selected", $result);
	$result = preg_replace("/(<select id=\"SearchAfterYear\".*)<option value=\"$after_year\"/", "\$1<option value=\"$after_year\" selected", $result);

	print $result;
}

elseif ( $_REQUEST['NewWindow'] && !$_REQUEST['NewUser'] )
{
	// User is not new, and doesn't want to display new windows
	print $atmail->parse("html/$atmail->Language/{$var['logintype']}/{$var['logintype']}.html", $var);
}
elseif ( $_REQUEST['NewWindow'] && $_REQUEST['NewUser'] && $var['logintype'] == 'xp')
{
	// Print the XP interface without a new window
	print "<script>location.href='parse.php?file=html/$atmail->Language/{$var['logintype']}/xp.html'</script>";
}
elseif ( $_REQUEST['NewWindow'] && $_REQUEST['NewUser'] && $var['logintype'] == 'xul')
{
	// Print the XP interface without a new window
	print "<script>location.href='parse.php?file=html/$atmail->Language/{$var['logintype']}/xul.html'</script>";
}
elseif ( $var['logintype'] == 'xul')
{
	// Print the XUL interface without a new window and with XUL header
	print "<script>location.href='parse.php?file=html/$atmail->Language/{$var['logintype']}/xullogin.html&XUL=1'</script>";
}
elseif ( $var['logintype'] == 'xp')
{
	// Print the XP interface without a new window
	print "<script>location.href='parse.php?file=html/$atmail->Language/{$var['logintype']}/{$var['logintype']}.html&frame=1'</script>";
}
elseif ( $var['logintype'] == 'simple')
{
	// Print the simple interface template
	print $atmail->parse("html/$atmail->Language/{$var['logintype']}/{$var['logintype']}.html", $var);
}

$log = new Log(array('Account' => "$atmail->username@$atmail->pop3host"));

// Log the access
$log->write_log( "Login", "Access from {$_SERVER['REMOTE_ADDR']}");

$atmail->end();

?>