<?php

// +----------------------------------------------------------------+
// | compose.php													|
// +----------------------------------------------------------------+
// | Source-code (C) CalaCode.com 1998-2005 . All rights reserved	|
// | See http://calacode.com/license.ehtml for license agreement	|
// +----------------------------------------------------------------+
// | Date: Febuary 2005												|
// +----------------------------------------------------------------+


require_once('header.php');

require_once('Session.php');
require_once('Global.php');
require_once('Log.php');
require_once('SendMsg.php');
require_once('PGP.php');
require_once('Mail/RFC822.php');

session_start();


// get global settings from config file
global $settings, $pref;
$var = array();

$atmail = new AtmailGlobal();
$auth =& $atmail->getAuthObj();
$atmail->httpheaders();

$atmail->status = $auth->getuser( $atmail->SessionID );

$atmail->username = $auth->username;
$atmail->pop3host = $auth->pop3host;

// check for language version
if (!$atmail->Language)
	$atmail->Language = $pref['Language'];


// Print the error screen if the account has auth errors, or session timeout.
if ( $atmail->status == 1 )
	$atmail->auth_error();
if ( $atmail->status == 2 )
	$atmail->session_error();

// Which function
$var['func'] = $_REQUEST['func'];

// Check for an attachment upload that has gone over post_max_size
// Set func to 'attachment' as $_POST will be empty.
if (isset($_GET['sending_attachment']) && !count($_POST) && !count($_FILES)) {
	$var['func'] = 'attachment';
}

// Load the account preferences
$atmail->loadprefs();


// check if allowed to use editor
if ($atmail->HtmlEditor == 1)
{
	// Allow the HTML editor for Mozilla/Gecko/Firefox
	if (strpos($_SERVER['HTTP_USER_AGENT'], 'Mozilla') !== false && strpos($_SERVER['HTTP_USER_AGENT'], 'Gecko') !== false && strpos($_SERVER['HTTP_USER_AGENT'], 'Safari') === false && $_REQUEST['HtmlEditor'] != 2 && $settings['HtmlEditor'] == 1)
	{
		$atmail->HtmlEditor = 1;
	}
	elseif ($atmail->browser == 'ns' && $atmail->LoginType != 'xul' || strpos($_SERVER['HTTP_USER_AGENT'], 'Mac') !== false)
	{
		$atmail->HtmlEditor = 0;
	}
	elseif ($_REQUEST['HtmlEditor'] == 2 )
	{
		$atmail->HtmlEditor = 0;
	}
	elseif ($_REQUEST['HtmlEditor'] == 1 )
	{
		$atmail->HtmlEditor = 1;
	}
}


// Choose what type of editor we are using
if ($atmail->HtmlEditor == 1)
{
    // Toggle the Mozilla HTML editor if this browser is used, otherwise the standard
	if ($atmail->browser == 'ns' && !$atmail->XUL)
		$var['file'] = "composehtml.html";
	else
		$var['file'] = "composehtml.html";

	// Change spaces to a new line if a standard signature ( not a message template )
	if (strpos($atmail->Signature, '<!-- TEMPLATE -->') === false)
	{
	    $atmail->Signature = str_replace("\n", '<BR>', $atmail->Signature);
	    $atmail->Signature = "<BR>" . $atmail->Signature ;
	}
}
elseif( ($atmail->LoginType == "xp" || $atmail->XUL) && $atmail->HtmlEditor != 1)	{
	$var['file'] = "composehtml.html";
	$atmail->Signature = "\n\n" . $atmail->Signature . "\n\n";

} else
    $var['file'] = "composetext.html";

// Parse the users custom stylesheet
$var['atmailstyle'] = $atmail->parse("html/$atmail->Language/$atmail->LoginType/atmailstyle.css");

// Load the time to display in the compose window
$var['localtime'] = strftime("%c");

// Create a unqiue number - Each compose screen is unique. Used to
// reference which attachments are for what window. Based on the
// PID and a random number.
$var['unique'] = $atmail->param_escape('unique');
$var['delete'] = $_REQUEST['delete'];

if ( !$var['unique'] )
{
    $var['unique'] = getmypid() + rand(0, 1000);
    //$var['unique'] =~ s/\..*//g;
}

// Avoid any fake/malformed unique ID, e.g ../ in pathname
$var['unique'] = preg_replace('/\.\.\//', '', $var['unique']);

// see if something is cached
if (file_exists($atmail->tmpdir .  ".ht$auth->SessionID"))
	$var['PgpPass'] = 1;

// The From address of our
$var['FromAddress'] = $atmail->loadpersonalities();

// Calculate the height of the menubar ( if the Webadmin user toggles off certain features )
$h = $atmail->calcmenu_height();
foreach($h as $k => $v)
	$var[$k] = $v;

// Display the attachment modal window
if ( $var['func'] == "attachmentmodal" )
{
    print $atmail->parse("html/$atmail->Language/$atmail->LoginType/attachmentmodal.html", $var);
}

elseif ( $var['func'] == "attachmentmodalframe" ) {
	$var['maxfilesize'] = ini_get('upload_max_filesize');
	if (!is_numeric($var['maxfilesize'])) {
	    if (strpos($var['maxfilesize'], 'M') !== false)
	        $var['maxfilesize'] = intval($var['maxfilesize'])*1024*1024;
	    elseif (strpos($var['maxfilesize'], 'K') !== false)
	        $var['maxfilesize'] = intval($var['maxfilesize'])*1024;
	    elseif (strpos($var['maxfilesize'], 'G') !== false)
	        $var['maxfilesize'] = intval($var['maxfilesize'])*1024*1024*1024;
	}
    print $atmail->parse("html/$atmail->Language/$atmail->LoginType/attachment.html", $var );
}
// Rename an attachment, when forwarding via Ajax
elseif( $var['func'] == "renameattach")	{

    $sendmsg = new SendMsg(array('Account' => "$atmail->username@$atmail->pop3host"));
	$AttachmentList = $_REQUEST['Attachment'];

	// Loop through each attachment to rename on disk
		if(is_array($AttachmentList))
		foreach($AttachmentList as $attach)	{
			$attach = $atmail->myunescape($attach);
			$sendmsg->renameattach($var['unique'], $attach);
		}

		echo "<ATTACH STATUS='OK'/>";

	$atmail->end();
}

elseif ($var['func'] == "attachmentmodallist" )
{
    $icon = $atmail->icon_hash();

    $sendmsg = new SendMsg(array('Account' => "$atmail->username@$atmail->pop3host"));

    // Delete the selected attachment
    if ( $var['delete'] )
   		$var['status'] = $sendmsg->delete_attachment($var['delete'], $var['unique']);

    // List the number of attachments . Based on the unique compose
    // window and our logged in account
    $h = $sendmsg->list_attachments($var['unique']);

    foreach ($h as $k => $v)
    {
        $var['filename'] = $k;
        if ( preg_match('/\.(\w+)$/', $var['filename'], $match) )
        	$var['ext'] = $match[1];

        $var['size'] = $v['size'];
        $var['mime'] = $v['mime'];

        // Load the icon for the filename
        $var['icon'] = $icon[strtolower($var['ext'])];

        // Use the standard if none exists
        if ( !$var['icon'] )
        	$var['icon'] = "plain.gif";

		$var['AttachNames'] .= "{$var['filename']}; ";
        // Build the HTML table that lists the attachments
        $var['attachments'] .= $atmail->parse("html/$atmail->Language/$atmail->LoginType/attachfilemodal.html", $var );

		// Increment the counter ( for the Javascript id field )
		$var['id']++;

    }

	$var['AttachNames'] = preg_replace('/; $/', '', $var['AttachNames']);

    print $atmail->parse("html/$atmail->Language/$atmail->LoginType/attachmentmodallist.html", $var );

}

// Print the attachment window
elseif ( $var['func'] == "attachment" )
{
    $icon = $atmail->icon_hash();

    $var['delete'] = $_REQUEST['delete'];
    $var['unique'] = $atmail->param_escape('unique');

    $sendmsg = new SendMsg(array('Account' => "$atmail->username@$atmail->pop3host"));

    // Delete the selected attachment
    if (isset($var['delete'])) {
    	$var['status'] = $sendmsg->delete_attachment( $var['delete'], $var['unique'] );
	}
    // Upload an attachment to the server if required
	elseif (isset($_FILES['fileupload']))
	{
		$var['status'] = $sendmsg->add_attachment($var['unique']);
		if ($var['status'] === false) {
			print $atmail->parse("html/$atmail->Language/msg/attachtoolarge.html");
		}
	} elseif (isset($_GET['sending_attachment'])) {
		// Probably exceeded post_max_size if we get here
		print $atmail->parse("html/$atmail->Language/msg/attachtoolarge.html");
	}

    // List the number of attachments . Based on the unique compose
    // window and our logged in account
    $h = $sendmsg->list_attachments( $var['unique'] );

    foreach ($h as $k => $v)
    {
        $var['filename'] = $k;
        if ( preg_match('/\.(\w+)$/', $var['filename'], $match) )
        	$var['ext'] = $match[1];

        $var['size'] = $v['size'];
        $var['mime'] = $v['mime'];

        // Load the icon for the filename
        $var['icon'] = $icon[ strtolower( $var['ext'] ) ];

        // Use the standard if none exists
        if ( !$var['icon'] )
        	$var['icon'] = "plain.gif";

		$var['AttachNames'] .= "{$var['filename']} ; ";
        // Build the HTML table that lists the attachments
        $var['attachments'] .= $atmail->parse("html/$atmail->Language/$atmail->LoginType/attachfile.html", $var);

    }

    print $atmail->parse("html/$atmail->Language/$atmail->LoginType/attachment.html", $var);

}

elseif ( $var['func'] == "reply" || $var['func'] == "spellcheck" )
{
    // Only use if nessasary , otherwise too much overhead if user
    // is simply composing a new message.
    require_once('ReadMsg.php');

    // Which email to read
    $var['id']     = $_REQUEST['id'];
    $var['type']   = $atmail->param_escape('type');
    $var['folder'] = $_REQUEST['folder'];
	$var['cache']  = $_REQUEST['cache'];

	// Flag we are a draft
	if ($var['folder'] == 'Drafts')
		$var['DraftID'] = $var['id'];

    // A local Inbox for POP3 mail
    if ( !$atmail->LeaveMsgs && !$domains[ $atmail->pop3host ] )
    	$atmail->MailType = $atmail->Mode;

    $email = new ReadMsg(array(
    	'Username'  => $atmail->username,
     	'Pop3host'  => $atmail->pop3host,
      	'Password'  => $auth->password,
      	'Type'      => $atmail->MailType,
      	'Mode'      => $atmail->Mode,
	  	'SessionID' => $auth->SessionID,
	  	'DateFormat' => $atmail->DateFormat,
  		'TimeFormat' => $atmail->TimeFormat,
		'Action'    => $var['type'])
    );

    $email->File = $_REQUEST['spellcheck'];

    // Multiple email forwarding
    if (is_array($var['id'])) {

        $email->rawemail = true;

        foreach ($var['id'] as $id) {

            $email->reademail( $id, $var['folder'], '');

            $i = 1;

            if (preg_match('/Subject:\s*(.+)/i', $email->rawbody, $m)) {
               $name = GetMail::quote_header($m[1]);
            } else {
                $name = time();
            }

            while (file_exists($atmail->tmpdir . "$name.eml")) {
               if ($i == 1)
                   $name = "{$name}_1";
               else
                   $name = preg_replace('/_\d+$/', $name, "_$i");

               $i++;
            }

            $name = "$name.eml";

            $fh = fopen("$atmail->tmpdir/$atmail->Account-{$var['unique']}-$name", 'w');
            fwrite($fh, $email->rawbody);
            fclose($fh);
            $var['FileAttachments'] .= "$name; ";
        }

    } else {
        $email->reademail( $var['id'], $var['folder'], '', $var['cache'] );
    }

	// If the message is marked encrypted, attempt to decode the message
	if ( $email->Encrypt )
	{
		$email->txt	= $email->decryptmsg( $email->txt, $_REQUEST['pgppass'] );
		$email->html = $email->decryptmsg( $email->html, $_REQUEST['pgppass'] );
	}

	// Remove any defanged HTML tags ( they are parsed out by @Mail when reading a message )
	$email->html = preg_replace('/<\/?DEFANGED_HTML>/i', '', $email->html);

	// Toggle our from address
	$from = $email->from;
	$var['FromAddress'] = str_replace("'$from'>", "'$from' selected>", $var['FromAddress']);

    // Add in the Re , if one does already exist, and in some other lanugages.
	if ( $var['type'] == "replyall" || $var['type'] == "reply" && $var['folder'] != "Drafts"
	&& !preg_match('/^Re.*?:/i', $email->subject) && !preg_match('/^Ynt:/i', $email->subject)
	&& !preg_match('/^TR/i', $email->subject) && !preg_match('/^Oggetto:/i', $email->subject)
	&& !preg_match('/^VS:/i', $email->subject) && !preg_match('/^Awt:/i', $email->subject)
	&& !preg_match('/^Aw:/i', $email->subject) && !preg_match('/^TR:/i', $email->subject)
	&& !preg_match('/^R:/i', $email->subject) && !preg_match('/^RES:/i', $email->subject)
	)
		$email->subject = "Re: $email->subject";

    if ( $var['type'] == "reply" || $var['type'] == "replyall" )
    {
		// Reply to the address in the Reply-To header, otherwise default to the From

		if ( $var['type'] == "replyall" )
		{
			$tmp = array();

			$rfc822 = new Mail_RFC822;

	        // Loop through each To/CC/From field and add to the replyall
	        foreach ( array('to', 'cc', 'from') as $type )
	        {
				$email->$type = str_replace(array('&lt;', '&gt;'), array('<', '>'), $email->$type);

				$groups = $rfc822->parseAddressList($email->$type);
				//var_dump($groups);

	            foreach ($groups as $group)
	            {
					$name = $group->personal;

					// Replace ", ' and , from the name, cleanup and parse the address below
					//$name = str_replace('\'', '', $name);
					$name = str_replace('"', '&quot;', $name);
					$name = str_replace(',', '', $name);

					$mail = $group->mailbox;
					$host = $group->host;

					if(strpos($mail, 'Shared Group') !== false)
						$mailaddr = "$mail";
					elseif(strpos($mail, ' Group') !== false)
						$mailaddr = "$mail";
					elseif($name)
						$mailaddr = "$name <$mail@$host>";
					elseif($mail)
						$mailaddr = "<$mail@$host>";
					else
						$mailaddr = '';

	                // Skip adding the users email, if already found in a header
	                if ( $tmp[$mail.$host] )
	                	continue;

	                $tmp[$mail.$host] = 1;

	             	$mailaddr = str_replace(array('<', '>'), array('&lt;', '&gt;'), $mailaddr);

	                // Append to the list of users to send
	                if ($type == "cc")
						$var['Cc'] .= ", " . $mailaddr;
					else
						$var['To'] .= ", " . $mailaddr;
				}
	        }

	        // Cleanup any stray , characters
	        $var['To'] = preg_replace('/^, /', '', $var['To']);
	        $var['To'] = preg_replace('/, $/', '', $var['To']);

	        // Cleanup any stray , characters
	        $var['Cc'] = preg_replace('/^, /', '', $var['Cc']);
	        $var['Cc'] = preg_replace('/, $/', '', $var['Cc']);

	    }
	    elseif ( $var['type'] == "reply" )
	    {
			// First respond to the email-address in Reply-To. Otherwise, use the From field
			$var['To'] = ($email->replyto)? $email->replyto : $email->from;

	        // Escape any " characters that will interfere with the input field
	        $var['To'] = str_replace('"', '&quot;', $var['To']);

	        // remove other characters from the field - Skip ' and "
	        $var['To'] = str_replace(array("\n", "\r"), '', $var['To']);
	    }

	    if ( $var['folder'] != "Drafts" )
	    {
	        $var['head'] = "On $email->date , " . str_replace(array('<', '>'), '', $email->from) . " sent:\n";
	    }

	    if ( preg_match('/html|alternative|mixed/', $email->mimetype) )
	    {
	        $var['Msg'] = ($email->html != '')? $email->html : $email->txt;

	        if ( $var['folder'] != "Drafts" && $atmail->HtmlEditor )
	        {
	            if ( $atmail->LoginType == "xp" )
	                $head = '#5167C6';

	            else
	                $head = $atmail->HeaderColor;

	            // strip <style> tags
	            $var['Msg'] = ReadMsg::strip_style($var['Msg']);

	            // Quote the message in blockquotes for HTML encoding.
	            $var['Msg'] = "<blockquote style='BORDER-LEFT: $head 2px solid; MARGIN-LEFT: 5px; MARGIN-RIGHT:0px; PADDING-LEFT: 5px; PADDING-RIGHT: 0px'>{$var['Msg']}</blockquote>";
	        }
	        elseif ( !$atmail->HtmlEditor && $var['folder'] != "Drafts" )
	        {
	            $var['Msg'] = ReadMsg::strip_style($var['Msg']);

	            // strip out leading whitespace
	            $var['Msg'] = preg_replace('/^ +/m', '', $var['Msg']);

	            // Intelligently convert HTML to text
                require_once('class.html2text.inc');
                $html2text = new html2text($var['Msg']);
                $var['Msg'] = $html2text->get_text();

	            //$var['Msg'] = str_replace(array('<br>', '<BR>', '<p>', '<P>'), "\n", $var['Msg']);
	            $var['Msg'] = ltrim($var['Msg']);

	            $lines = preg_split("/\r|\n/", $var['Msg']);
				$msg = '> ';
				foreach ($lines as $line)
				{
					$line = ltrim($line);
					if (strlen($line) > 75)
						$msg .= wordwrap($line, 75, "\n"."> ", 1);
					else
						$msg .= "$line\n> ";
				}

				$var['Msg'] = $msg;
	        }
		}
	    else
	    {
	        $var['Msg'] = ($email->txt)? $email->txt : $email->html;

	        if ( $var['folder'] != "Drafts" )
	        {
				if ($atmail->HtmlEditor)
				{
		            if ( $atmail->LoginType == "xp" )
		                $head = '#5167C6';

		            else
		                $head = $atmail->HeaderColor;

					$var['Msg'] = "<blockquote style='BORDER-LEFT: $head 2px solid; MARGIN-LEFT: 5px; MARGIN-RIGHT: 0px; PADDING-LEFT: 5px; PADDING-RIGHT: 0px'>{$var['Msg']}</blockquote>";

				}
				else
				{
					$lines = preg_split("/\r|\n/", $var['Msg']);// preg_replace("/^(.*)$/", '&gt;$1', $var['Msg']);
					$msg = '&gt; ';
					foreach ($lines as $line)
					{
						$line = ltrim($line);
						if (strlen($line) > 75)
							$msg .= wordwrap($line, 75, "\n"."&gt; ", 1);
						else
							$msg .= "$line\n&gt; ";
					}

					$var['Msg'] = $msg;
				}

	        }
	    }
    }
    elseif ( $var['type'] == "replyall" )
    {
        $var['To'] = $email->from;
        $var['To'] .= ", " . $email->to;

    }
    elseif ( $var['type'] == "forward" || $var['folder'] == "Drafts" )
    {
        // If the message being forwarded has attachments, send
        // the attachments as well. Note in the email message it
        // includes attachments
        extract_attachments($email);

        // See if we have any meassage/RFC822 attachments
	    foreach ($email->attachedemails as $path) {
	        $email2 = new ReadMsg(array(
	          'Username'   => $atmail->username,
	          'Pop3host'   => $atmail->pop3host,
	          'Password'   => $auth->password,
	          'Type'       => $atmail->MailType,
	          'Mode'       => $atmail->Mode,
	          'SessionID'  => $auth->SessionID,
	          'Language'   => $atmail->Language,
	          'DateFormat' => $atmail->DateFormat,
	          'TimeFormat' => $atmail->TimeFormat,
	          'LoginType'  => $type,
	          'head'       => 1,
	          'rawemail'   => $var['rawemail'])
	        );

	        $email2->reademail('', '' ,'', '', $path);

	        if ($email2->html)
	            $type = 'html';
	        elseif ($email2->txt)
	            $type = 'txt';
	        elseif ($email2->multiparttxt)
	            $type = 'multiparttxt';

	        $myvars = array('subject' => $email2->subject, 'from' => htmlentities($email2->from), 'to' => htmlentities($email2->to), 'date' => $email2->date, 'body' => $email2->$type);

	        if ($email->html || ($email->html && $email->txt)) {
	            $email->html .= $atmail->parse("html/$atmail->Language/fwdmsg.html", $myvars);
	        }
	        elseif ($email->txt) {
	            $email->txt .= $atmail->parse("html/$atmail->Language/fwdmsg.html", $myvars);
	        }

	        extract_attachments($email2);
	    }

		$var['FileAttachments'] = preg_replace('/; $/', '', $var['FileAttachments']);

        // Stick the attachment msg at the top of the forward
        if($var['attach'] && $atmail->LoginType != "xp")
        	$var['Msg'] = $var['attach'] . "\n";

		if ($var['folder'] != "Drafts")
		{
	        if ( substr($email->subject, 0, 4) !=  'Fwd:' )
	        	$email->subject = "Fwd: $email->subject";

	        $var['Subject'] = $email->subject;
	        $var['Msg']     .= ($email->html)? $email->html : $email->txt;

            // If forwarding one email, make the message body
            if(!is_array($var['id']))	{

                $from = str_replace(array('<', '>'), '', $email->from);
                $to = str_replace(array('<', '>'), '', $email->to);
                $subject = str_replace(array('<', '>'), '', $email->subject);

            	$var['head'] = <<<_EOF
            	{$var['attach']}
            	----- Original Message -----
            	From: $from
            	To: $to
            	Sent: $email->date
            	Subject: $subject


_EOF;

            	$var['head'] .= '&lt;hi&gt;';
            } else {
            // Otherwiswe we are fowarding multiple, leave the body as-is, forwarded messages listed as an attachment
            	$var['head'] = " ";

            }

            // Intelligently convert HTML to text if need be
            if ($email->html && $atmail->HtmlEditor == 0) {
                require_once('class.html2text.inc');
                $html2text = new html2text($var['Msg']);
                $var['Msg'] = $html2text->get_text();
            }

		}
		else
		{
			// If we are composing a draft message, tack on the previous subject/to/cc fields
			$var['Subject'] = $email->subject;
			$var['Msg']     = ($email->html)? $email->html : $email->txt;
			$var['To'] 		= $email->to;
			$var['Cc'] 		= $email->cc;
			// Don't add the signature again when opening draft message
			$atmail->Signature = "";
		}

        #$var['Msg'] = $var['head'] . $var['Msg'];
    }
    elseif ( $var['func'] == "spellcheck" )
    {
		// List the number of attachments . Based on the unique compose
		// window and our logged in account
		$sendmsg = new SendMsg(array('Account' => "$atmail->username@$atmail->pop3host"));

		$h = $sendmsg->list_attachments( $var['unique'] );

		foreach (array_keys($h) as $k)
			$var['FileAttachments'] .= "$k; ";

		$var['FileAttachments'] = preg_replace('/; $/', '', $var['FileAttachments']);

		// Make if the user has replied/forwarded the message
		// Used to update the UIDL once the message has been sent
		$var['type'] = $atmail->escape_html($_REQUEST['msgtype']);

        if ( !$atmail->HtmlEditor )
        {
            $var['Msg'] = $email->txt;
            $var['Msg'] = preg_replace('/<style.*?>.*?<\/style>/i', '', $var['Msg']);
            $var['Msg'] = preg_replace('/<.*?>/', '', $var['Msg']);
        }
        else
            $var['Msg'] = $email->html ? $email->html : $email->txt;

        $var['To']       = str_replace(array('>', '<', '"'), array('&gt;', '&lt;', '&quot;'), $email->to);
        $var['Cc']       = str_replace(array('>', '<', '"'), array('&gt;', '&lt;', '&quot;'), $email->cc);
        $var['Bcc']      = str_replace(array('>', '<', '"'), array('&gt;', '&lt;', '&quot;'), $email->bcc);
        $var['Priority'] = $email->priority;

        if ( $var['Priority'] == "Low" )
        	$var['Priority'] = "5";
        elseif ( $var['Priority'] == "High" )
        	$var['Priority'] = "1";
        elseif ( !$var['Priority'] || $var['Priority'] == "Normal" )
        	$var['Priority'] = "0";

        $atmail->Signature = "";
    }

    // Check what editor we are using. Escape HTML chars otherwise. Turn
    // line breaks into <BR>'s if using HTML editor
    if ( $atmail->HtmlEditor && $var['func'] != "spellcheck" )
    {
        $var['head'] = str_replace("\n", '<BR>', $var['head']);

		// Create a standard reply, or format the message for a HTML template
		if ( strpos($atmail->Signature, '<!-- TEMPLATE -->') === false)
		{
	        $var['Msg'] = "<BR><BR><B>{$var['head']}</b>" . $var['Msg'];
	        $atmail->Signature = str_replace("\n", '<BR>', $atmail->Signature);
	        $atmail->Signature = "<BR>" . $atmail->Signature;
		}
		else
		{
			// Detect if the message is written from the local system, and not a reply from Outlook
			if ( strpos($var['Msg'], '<!-- START FOOTER -->') !== false && strpos($var['Msg'], '<DEFANGED_META content="MSHTML') !== false)
			{
				// Chop the previous header and footer
				$var['Msg'] = preg_replace('/<!-- START FOOTER -->.*<!-- END FOOTER -->.*/', '', $var['Msg']);
				$var['Msg'] = preg_replace('/.*<!-- END HEAD -->/', '', $var['Msg']);

				// Insert the message into our template and format to the browser
				$atmail->Signature = str_replace('<!-- TEMPLATE -->', "<p><br><br></p><b>{$var['head']}</b>{$var['Msg']}", $atmail->Signature);
			}
			else
			{
				$atmail->Signature = str_replace('<!-- TEMPLATE -->', "<p><br><br></p><b>{$var['head']}</b>{$var['Msg']}{$var['MsgHead']}", $atmail->Signature);
			}

			// Do not append the original message to the email, it is embeded into the signature
			$var['Msg'] = null;
		}

        #$var['Msg'] =~ s/\n/<BR>/g;a
    }
    elseif ( $var['func'] != "spellcheck" )
    {
        $var['Msg'] = $var['head'] . $var['Msg'];

		// Take out stylesheet references and cleanup the source.
		$var['Msg'] = preg_replace('/<style.*?>.*?<\/style>/ims', '', $var['Msg']);
        $var['Msg'] = preg_replace('/<.*?>/ms', '', $var['Msg']);
		$var['Msg'] = strip_tags($var['Msg']);
    }
    elseif ( $var['func'] == "spellcheck" && $atmail->HtmlEditor )
        $var['Msg'] = str_replace(array("\n", "\r"), '', $var['Msg']);

	// Calculate the height of the menubar ( if the Webadmin user toggles off certain features )
	$h = $atmail->calcmenu_height();
	foreach($h as $k => $v)
		$var[$k] = $v;

    // Print the default compose or the corporate style
    print $atmail->parse(
      "html/$atmail->Language/$atmail->LoginType/{$var['file']}{$var['misc']}", array(
	      'atmailstyle'			=> $var['atmailstyle'],
	      'localtime'   		=> $var['localtime'],
	      'To'          		=> $var['To'],
	      'Subject'     		=> $email->subject,
	      'Msg'         		=> $var['Msg'],
	      'Signature'   		=> $atmail->Signature,
	      'type'        		=> $var['type'],
	      'UIDL'        		=> $email->UIDL,
	      'unique'      		=> $var['unique'],
	      'Cc'          		=> $var['Cc'],
	      'Bcc'         		=> $var['Bcc'],
	      'Priority'    		=> $var['Priority'],
	      'func'        		=> $var['func'],
	      'PgpPass'     		=> $var['PgpPass'],
		  'FromAddress' 		=> $var['FromAddress'],
		  'Charset' 			=> $email->Charset,
		  'FileAttachments' 	=> $var['FileAttachments'],
		  'DraftID'				=> $var['DraftID'],
		  'MenuPullHelpHeight' 	=> $var['MenuPullHelpHeight'],
		  'ReadReceipt'			=> $email->ReadReceipt,
		  'id'        			=> $var['id'])
	);

    // Otherwise, print the compose screen
}
elseif ( $var['func'] == "encrypt" )
{
	$var['To']  = $_REQUEST['emailto'];
    $var['Cc']  = $_REQUEST['emailcc'];
    $var['Bcc'] = $_REQUEST['emailbcc'];
    $var['Subject'] = $_REQUEST['emailsubject'];
    $var['Msg'] = $_REQUEST['emailmessage'];
    $var['Priority'] = $_REQUEST['emailpriority'];
    $var['unique'] = $atmail->escape_html($_REQUEST['unique']);
    $var['UIDL'] = $_REQUEST['UIDL'];
    $var['type'] = $atmail->escape_html($_REQUEST['type']);
    $var['Draft'] = $_REQUEST['Draft'];
    $var['code'] = $_REQUEST['code'];
    $var['HtmlEditor'] = $_REQUEST['HtmlEditor'];

    $pubKeys = array();

	if ($atmail->MailDir)
		$userWrkDir	= $atmail->MailDir;
	else
		$userWrkDir= $atmail->tmpdir;

	$ownFile = $atmail->tmpdir . ".ht.".$auth->SessionID;

	$pgp = new PGP( array('wrkDir' => "$userWrkDir/pgp", 'ownFile' => $ownFile) );

    if (($var['code'] == 'a' || $var['code'] == 'A') && !($pgp->ErrorMsg)) //attach user's public key
    {
		$msgTmp = $pgp->retrieveAsciiPub();

		// Turn newlines into <BR>'s for the HTML editor
		if ($var['HtmlEditor'] == 1)
			$msgTmp = str_replace("\n", "<BR>\n", $msgTmp);

    	$var['Msg'].= $msgTmp;
    }

    if (($var['code'] == 's' || $var['code'] == 'S') && !($pgp->ErrorMsg)) //if sign
    {
    	// verify you have something useful
    	if (!$pgp->Word) // if not cached
    	{
    		$pgp->Word = $_REQUEST['pgppass']; // take it from user
    	}

    	$allRecs = "{$var['To']},{$var['Cc']},{$var['Bcc']}";
        $allRecs = str_replace(array("<", ">"), '', $allRecs); // remove <>
        $recipients = preg_split('/\s+|,+|;+/', $allRecs);
    }

    if (($var['code'] == 'e' || $var['code'] == 'E') && empty($pgp->ErrorMsg)) // if encrypt
    {
    	// verify recipients have public key in address book
    	require_once('Abook.class.php');
    	$abook = new Abook( array('Account' => "$atmail->username@$atmail->pop3host") );
    	$allRecs = "{$var['To']},{$var['Cc']},{$var['Bcc']}";
    	$allRecs = str_replace(array("<", ">"), '', $allRecs); // remove <>
    	$recipients = preg_split('/\s+|,+|;+/', $allRecs);

    	foreach ($recipients as $recipient)
    	{
	    	if ( empty($recipient) || strpos($recipient, '@') === false) // empty or not address
	    		continue;
    		$pubKeys[$recipient] = $abook->getPublicKey($recipient);
    		if ( empty($pubKeys[$recipient]) )
    			$pgp->ErrorMsg.= "User $recipient has no public key in the Address Book\n" ;
    	}

    	if (!$pgp->ErrorMsg)
    	{
   	   		// import the users public keys in pubring
   			foreach ($recipients as $recipient)
   			{
   				if ( empty($recipient) )
   					continue;

   				// import if that's the case
   				if (!$pgp->existsKey($recipient))
   					$pgp->importKey($pubKeys[$recipient]);

   				// verify it was imported ok
   				if (!$pgp->existsKey($recipient))
   					$pgp->ErrorMsg .= "Public key for $recipient cannot be used (invalid format?)\n";
   			}
   		}
   	}

   	if ( preg_match('/e|s/i', $var['code']) && empty($pgp->ErrorMsg)) // if encrypt and/or sign
   	{
   		//the encryption/signing itself
    	$msgTmp = $pgp->encrypt("$atmail->username@$atmail->pop3host", $recipients, $var['Msg'], $var['code']);

		if($var['HtmlEditor'] == 1)
			$msgTmp = str_replace("\n", "<BR>\r\n", $msgTmp);

 		if (empty($pgp->ErrorMsg))
 			$var['Msg'] = $msgTmp;
    }

    if ( !empty($pgp->ErrorMsg) )
    	$var['Msg'] = $pgp->ErrorMsg . $var['Msg'] ;

    // Cleanup any unnessasary ,'s
    foreach ( array('To', 'Cc', 'Bcc') as $v )
    {
        $var[$v] = preg_replace('/^,/', '', $var[$v]);
        $var[$v] = preg_replace('/,$/', '', $var[$v]);
		$var[$v] = preg_replace('/^mailto:/', '', $var[$v]);
    }

    $var['type'] = "r";
    // see if something is cached now
	if ( file_exists($ownFile) )
		$var['PgpPass'] = 1 ;

    print $atmail->parse("html/$atmail->Language/$atmail->LoginType/{$var['file']}", $var);
}

elseif ($var['func'] == "new")
{
    // extract TO, CC, Bcc values if they are array
    if (isset($_POST['To']) && is_array($_POST['To'])) {
        $var['To'] = $atmail->translate_special(preg_replace("/^; /", '', $_POST['To'][0]));
    } else {
        $var['To']  = $atmail->loadParameter('To');
    }

    if (isset($_POST['Cc']) && is_array($_POST['Cc'])) {
        $var['Cc'] = $atmail->translate_special(preg_replace("/^; /", '', $_POST['Cc'][0]));
    } else {
        $var['Cc']  = $atmail->loadParameter('Cc');
    }

    if (isset($_POST['Bcc']) && is_array($_POST['Bcc'])) {
        $var['Bcc'] = $atmail->translate_special(preg_replace("/^; /", '', $_POST['Bcc'][0]));
    } else {
      $var['Bcc']  = $atmail->loadParameter('Bcc');
    }


    $var['Subject'] = $atmail->translate_special($atmail->loadParameter('subject'));
    $var['Msg'] = $atmail->translate_special($atmail->loadParameter('body'));

	//$var['Charset'] = $atmail->EmailEncoding;

    // Cleanup any unnessasary ,'s
    foreach ( array('To', 'Cc', 'Bcc') as $v )
    {
       $var[$v] = preg_replace('/^,/', '', $var[$v]);
       $var[$v] = preg_replace('/,$/', '', $var[$v]);
    }

    $var['type'] = "r";

    print $atmail->parse(
      "html/$atmail->Language/$atmail->LoginType/{$var['file']}", array_merge($var, array('Signature' => $atmail->Signature)) );
}

$atmail->end();

/**
 * Extract attachemnts from an email object
 *
 * @param unknown_type $email
 */
function extract_attachments(&$email)
{
	if (!is_array($email->attachname))
		return;

	global $atmail, $var;

	$tmpFiles = array();
    foreach ($email->attachname as $attach) {

        if ( !$attach['path'] )
        	continue;
        if ($attach['inline']) {
            copy($attach['path'], $atmail->tmpdir . "/$atmail->username@$atmail->pop3host-{$var['unique']}-cid:{$attach['cid']}-name:{$attach['name']}");
            $tmpFiles[] = "$atmail->username@$atmail->pop3host-{$var['unique']}-cid:{$attach['cid']}-name:{$attach['name']}";
        }
        else {

			$tmpname = $attach['name'];

			if (file_exists($atmail->tmpdir . "/$tmpname"))
			{
				// Unescape the filename to attach
				$file = $email->myunescape($tmpname);

	            // The attachment has been written to disk. Rename to attach to
	            // the email when sent
	            if ($atmail->LoginType != 'xp')
	            	$var['attach'] .= "$file ({$attach['size']} Kb) attached\n";

				$var['FileAttachments'] .= "$file; ";

				// Rename the attachment and attach to our unique message ID
	            rename( $atmail->tmpdir . "/$tmpname", $atmail->tmpdir . "/$atmail->username@$atmail->pop3host-{$var['unique']}-$file");

			} else {
				// We cannot determine the attachment name, rename the path to the new location
				$file = $email->myunescape($tmpname);
				if ($atmail->LoginType != 'xp')
					$var['attach'] .= "$file ({$attach['size']} Kb) attached\n";
				$var['FileAttachments'] .= "$file; ";

				// Rename the attachment and attach to our unique message ID
				rename($attach['path'], $atmail->tmpdir . "/$atmail->username@$atmail->pop3host-{$var['unique']}-$file");
			}
        }
    }
}


?>
