#!/usr/bin/perl

# Language module for @Mail
# Read a language template, and create a new HTML directory with the translations.

# Example
# perl lang.pl english "lang/english.lang"
# This will build a new HTML direcotry containing the interface of @Mail.

eval("use utf8");
use lib "/usr/local/atmailphp/webmail/libs";

if( $ENV{'GATEWAY_INTERFACE'} ||$ENV{'MOD_PERL'})       {
print "Content-Type: text/html\n\n";
print<<_EOF;
<h1>Installation Script Error</h1>
<p>The install.pl script can only be run via the command-line to configure \@Mail. Please read
<a href='http://atmail.nl/docs/install.html'>http://atmail.nl/docs/install.html</a> for information on
installing \@Mail.
</p>
_EOF
exit;
}

if ( $ARGV[0] =~ /all/i ) {

    opendir( DIR, "lang/languages/" )
      || print "Cannot read lang/languages/ dir: $!";
    my @files = readdir(DIR);

    #backup the 
    savehtml();

    foreach my $file (@files) {
        next if ( $file eq "." || $file eq ".." || $file =~ /^\./);
		next if ( $file eq "english" && $ARGV[0] eq "alls" );

		print "Translating $file .... \n";

        system("perl lang.pl $file lang/languages/$file/$file.lang");

#	newlang($file, "lang/languages/$file/$file.lang", "silent") if(-e "lang/languages/$file/$file.lang");
    }

}
else {

    if ( !$ARGV[0] ) {
        print
"Please specify the language name: e.g perl lang.pl english lang/languages/english/english.lang\n";
        exit;
    }

    if ( !$ARGV[1] ) {
        print
"Please specify the language file: e.g perl lang.pl english lang/language/english/english.lang";
        exit;
    }

    savehtml();
	 
    my $langname = $ARGV[0];
    $langname = lc($langname);

    $language{$langname} = ucfirst($langname);

    #Atmail::Config->writeconf();

    newlang( $langname, $ARGV[1], $ARGV[2] );

}

exit;

sub savehtml {
    #print "Backing up html template directory ...\n";
    #my $time = time();
    #system("cp -r lang/html /tmp/htmltemplate-$time");
}

sub newlang {
    $lang   = $_[0];
    $file   = $_[1];
    $volume = $_[2];
    %lang   = undef;

    print "Writing new Language $lang using $file $volume\n\n";

    open( F, $file ) || die "Cannot read $file : $!";
    binmode(F); #, ':utf8'); 
while (<F>) {
        my $line = $_;

        $line =~ /(.*?)=(.*)/;
        my ( $name, $value ) = ( $1, $2 );

        $name =~ s/^\s+//g;
        $name =~ s/\s+$//g;

        $value =~ s/^\s+//g;
        $value =~ s/\s+$//g;

        $lang{$name} = $value;
    }

    # Include our language name
    $lang{lang} = $lang;

	my $value;

    system("rm -rf ./lang/$lang");

    system("cp -r ./lang/html ./lang/$lang");

### TAKE OUT FOR PRODUCTION!!!
if($pref{sql_table} eq "atmail404new")	{
system("find /usr/local/atmail/webmail/lang/$lang -name \".svn\" | sed \"s/^/rm -rf /g\" | sh");
}
### TAKE OUT FOR PRODUCTION!!!

    html_search("./lang/$lang/");
    html_search("./lang/$lang/calendar/");
    html_search("./lang/$lang/help/");
    html_search("./lang/$lang/javascript/");
    html_search("./lang/$lang/javascript/htmleditor/");
    html_search("./lang/$lang/msg/");
    html_search("./lang/$lang/simple/");
    html_search("./lang/$lang/simple/heading/");
    html_search("./lang/$lang/xhtml/");
    html_search("./lang/$lang/xp/");
    html_search("./lang/$lang/xp/heading/");
    html_search("./lang/$lang/xp/calendar/");
    html_search("./lang/$lang/xul/");   
    html_search("./lang/$lang/xul/css/");   

    sleep(1);

    my $value;

            system("rm -rf ./html/$lang");
            system("mv ./lang/$lang ./html/$lang");
            print "New language installed to ./html/$lang/\n";

    if ( !-d "imgs/menubar-$lang" && !-d "lang/languages/$lang/menubar-$lang" )
    {

        if ( $volume ne "silent" ) {

            print "
Image Translation
-----------------

 - The imgs/menubar-$lang directory does not exist. To complete the translation of \@Mail
 you are required to modify the text for the menubar images.
  ";
            my $value = enterinfo( "
Icons for $lang could not be found.
  Copy English template to imgs/menubar-$lang ?", "Y" );

            if ( $value =~ /y/i ) {

                system("cp -r imgs/menubar-english imgs/menubar-$lang");
            }

        }

        elsif ( $volume eq "silent" ) {
            system("cp -r imgs/menubar-english imgs/menubar-$lang");
        }

    }

    if ( -d "lang/languages/$lang/menubar-$lang" ) {

        if ( $volume ne "silent" ) {

            my $value = enterinfo( "
Move image template from:
  lang/languages/$lang/menubar-$lang to imgs/menubar-$lang ?", "Y" );

            if ( $value =~ /y/i ) {
                print "Creating images ...\n\n";
                system("mv imgs/menubar-$lang /tmp/menubar-$lang-$time");
                system(
                  "mv lang/languages/$lang/menubar-$lang imgs/menubar-$lang");
            }

        }

        elsif ( $volume eq "silent" ) {
            print "Creating images ...\n\n";
            system("mv imgs/menubar-$lang /tmp/menubar-$lang-$time");
            system("mv lang/languages/$lang/menubar-$lang imgs/menubar-$lang");
        }

    }

}

# Add the new Language into the Config file
# This will craete the language popup in the login page
$language{$lang} = ucfirst($lang);

# Write the new conf
#Atmail::Config->writeconf();

system("chown -R nobody ./lang/html/")
  ;                                  # <-- Change the ownership of the directory
system("chmod -R 755 ./lang/html/"); # <-- Change the ownership of the directory

print "Copying existing templates" if ($files);

foreach ( keys %files ) {
    print "$_ = $files{$_}\n";
}

#}

sub html_search {
    my $dir = $_[0];

    print "Searching $dir";
    opendir( DIR, "$dir" );
    @folders = readdir(DIR);
    foreach $folder (@folders) {
        next
          if ( $folder eq "." || $folder eq ".." || $folder !~ /\.html$|\.js$|\.xhtml|\.css$/
          || $folder eq "change-perl.pl" );
        change_path( $dir, $folder );
    }
    print " done\n";
}
print "\n";

sub change_path {
    my $dir    = $_[0];
    my $folder = $_[1];

    #    print "Found $dir/$folder\n";
    print ".";
    open( F, "$dir/$folder" ) || die "$dir/$folder : $!";
    open( N, ">$dir/$folder.new" ) || die "$dir/$folder : $!";
	binmode(F);
	binmode(N);

    while (<F>) {
        my $line = $_;

        # Substituite the new var names
        $line =~ s/\$lang\['(.*?)'\]/$lang{$1}/g;
	
	# Take out those annoying ^M characters
	$line =~ s/\cM//g;

        # Change the Include files
        $line =~
          s/<!--Include="html\/(.*?)\//<!--Include="html\/$lang{lang}\//g;

        print N $line;
    }
    close(F);
    close(N);
    rename( "$dir/$folder.new", "$dir/$folder" )
      || die "$dir/$folder.new - $dir/$folder : $!";
    system("chmod 744 $dir$folder");
}

sub enterinfo {
    ( $txt, $var ) = @_;
    my $value;
    do { print "\033[1;32m $txt [$var]: \033[0;39m"; chop( $value = <STDIN> ); }
      while (0);
    $value = $var if ( !$value );
    print "\n";
    return $value;
}
