<?php

// +----------------------------------------------------------------+
// | Filters.php													|
// +----------------------------------------------------------------+
// | Maintain the filter database									|
// +----------------------------------------------------------------+
// | Source-code (C) CalaCode.com 1998-2006 . All rights reserved	|
// | See http://calacode.com/license.ehtml for license agreement	|
// +----------------------------------------------------------------+
// | Date: January 2006												|
// +----------------------------------------------------------------+

//require_once('../libs/Atmail/Config.php');
//use MIME::Parser;
//require_once('../libs/Atmail/Log.php');
//require_once('../libs/Atmail/SendMsg.php');

require_once('header.php');

class Filters
{

	var $log;
	var $db;
	var $SpamTreatment;
	var $AbookTrusted;
	var $AntiVirus;
	var $PassCode;
	var $SettingsLoaded;


	function Filters($arg=array())
	{
		global $atmail;

		$this->emailexp = '([^":\s<>()/;]*@[^":\s<>()/;]*)';

	    foreach ($arg as $k => $v)
	        $this->$k = $v;

		// Find our domain-name, used for the Spamsettings table
		list($this->username, $this->pop3host) = explode('@', $this->Account);

		if (is_a($atmail->db, 'SQL'))
			$this->db = $atmail->share_db();
		else
		{
			require_once('SQL.php');
			$this->db = new SQL;
		}
	}


	/**
	 * Add entry into Spam Settings
	 *
	 * @param array $arg
	 * @return boolean
	 */
	function addentry($arg)
	{
	    if (strlen($this->pop3host) == 0) {
            $where_clause = "domain is ?";
            $this->pop3host = null;
	    } else {
	        $where_clause =  "domain = ?";
	    }

		if (!$this->db->sqlgetfield("SELECT `value`
		                             FROM SpamSettings
		                             WHERE username = ? AND preference = ? AND value = ?
		                             AND ".$where_clause , array($arg['Account'], $arg['Header'], $arg['Value'], $this->pop3host)))
		{
			// Insert the entry into the DB, only if it does not yet exist
		    $query = "INSERT INTO SpamSettings (username, preference, value, domain) VALUES(?, ?, ?, ?)";
			$data = array($arg['Account'], $arg['Header'], $arg['Value'], $this->pop3host);
		    $this->db->sqldo($query, $data);
		}

	    return 0;
	}


	function delentry($id, $account = '')
	{
	    // Do not attempt to delete if no argument is given
	    if (strlen($id) == 0)
			return 0;

		if (strlen($account) > 0)
			$this->db->sqldo("delete from SpamSettings where prefid=? and username=?", array($id, $this->Account));
		else
			$this->db->sqldo("delete from SpamSettings where prefid=?", $id);

	    return 1;
	}


	function modentry($arg)
	{
		// Check the Filter value is a valid Regular Expression, otherwise return the error
	    $this->check_regex($arg['Value']);
		if ($this->regex_failed)
		{
			echo "regex failed!";
			return false;
		}

	    // Insert the message into the EmailDatabase table (header info only)
	    $query = "UPDATE Filter set
	              Header = ?, Value = ?, Score = ?, Account = ?,
	              Type = ?, Description = ?, Origin = ? where
	  			  id=?";
		$data = array($arg['Header'], $arg['Value'], $arg['Score'], $arg['Account'], $arg['Type'], $arg['Description'], $arg['Origin'], $arg['id']);
	    $this->db->sqldo($query, $data);

	    return true;
	}


	// Check a string is a valid regular expression
	function check_regex($value)
	{
	    // Create a test string
	    $test = 'testing';

		// A bit of a hack but all i could think of at the time :)
		// using set_error_handler() to catch any error that occurs
		// in the eval() below, then check error to see if it is due
		// to invalid regex expression (which is the only error we should get)

		// OK lets set our error handler
		set_error_handler(array($this, 'catch_error'));

	    // Eval the value to check if the regular expression is valid
	    eval("preg_match('/$value/', '$test');");

		// revert back to PHP error handler
		restore_error_handler();
	}

	function catch_error($errno, $errstr)
	{
		if ($errno == E_WARNING && strpos($errstr, 'preg_match()') !== false)
			$this->regex_failed = 1;

		echo "<h2>$errstr</h2>";
	}

	// Return a hash containing the filter preferences
	function returnfilter($id)
	{
		return $this->db->sqlhash('select * from SpamSettings where prefid=?', $id);
	}


	function displayresults($arg)
	{
		$sql = '';

		foreach ($arg AS $k => $v)
		{
			if ($k == "Sort" || !$v)
				continue;

			$k = Filter::cleanSqlFieldNames($k);

			$sql .= "$k = " . $this->db->quote($v) . " and ";
		}

		if ($this->Account)
			$sql .= " username = " . $this->db->quote($this->Account);

		// Take away the last AND query
		$sql = preg_replace('/ and $/', '', $sql);


		return $this->db->sqlarray("select prefid from SpamSettings where $sql order by ?", $arg['Sort']);
	}


}

?>