<?php
// +----------------------------------------------------------------+
// | task.php														|
// +----------------------------------------------------------------+
// | Function:  Handles 'tasks' for @Mail's calendaring function	|
// +----------------------------------------------------------------+
// | Source-code (C) CalaCode.com 1998-2005 . All rights reserved	|
// | See http://calacode.com/license.ehtml for license agreement	|
// +----------------------------------------------------------------+
// | Date: September 2005											|
// +----------------------------------------------------------------+

require_once('header.php');

require_once('Session.php');
require_once('Global.php');
//require_once('GetMail.php');
require_once('Calendar.php');

session_start();

$atmail = new AtmailGlobal();
$auth =& $atmail->getAuthObj();

$var = array();

$atmail->httpheaders();

$atmail->status = $auth->getuser();

$atmail->username = $auth->username;
$atmail->pop3host = $auth->pop3host;

// Print the error screen if the account has auth errors, or session timeout.
if ( $atmail->status == 1 )
	$atmail->auth_error();

elseif ( $atmail->status == 2 )
	$atmail->session_error();

// Load the account preferences
$atmail->loadprefs();

$param = array_merge($_POST, $_GET);

// If using the XUL interface, toggle to use the XP HTML templates
if ($atmail->LoginType == "xul")
{
	$atmail->LoginType = "xp";
	if (!$var['func'])
		$var['func'] = "start";
}

$var['hour']   = $param['hour'];
$var['minute'] = $param['minute'];
$var['day']    = $param['day'];
$var['month']  = $param['month'];
$var['year']   = $param['year'];
//$var['type']   = $param['type'];
$var['Refresh'] = $param['Refresh'];
$var['WriteSelectedGroups'] = $param['WriteSelectedGroups'];
$var['WriteSelectedUsers'] = $param['WriteSelectedUsers'];
$var['ReadSelectedGroups'] = $param['ReadSelectedGroups'];
$var['ReadSelectedUsers'] = $param['ReadSelectedUsers'];
$var['start_page'] = $param['start_page'];

if ( $var['start_page'] )
    $var['extra'] = 'href="util.php?func=start" target="emailwin"';

else
    $var['extra'] = 'href="task.php?func=todo" target="bottomFrame"';

$func = $param['func'];

$cal = new Calendar(array(
  'username' => $atmail->username,
  'pop3host' => $atmail->pop3host,
  'userfrom' => $atmail->userfrom)
);

$var['atmailstyle'] = $atmail->parse("html/$atmail->Language/$atmail->LoginType/atmailstyle.css");
$var['atmailstyle'] .= $atmail->parse("html/$atmail->Language/$atmail->LoginType/atmailstyle-form.css");

if ( $func == "new" )
    newtask();

elseif ( $func == "task" )
    menutask();

elseif ( $func == "add" )
    addtask();

elseif ( $func == "todo" )
    showtask();

elseif ( $func == "read" )
    readtask();

elseif ( $func == "Update" )
    updatetask();

elseif ( $func == "Delete" )
    deletetask();


$atmail->end();


//
// start function definitions
//

function menutask()
{
}

// View a calendar entry
function showtask()
{
	global $atmail, $cal, $param, $var;

	$var['Type'] = $param['Msg_Type'];

    // Move Tasks to complete if nessasary
    $del = $param['del'];

	if (is_array($del))
	{
		foreach ($del as $v)
		{
			$arr = explode(':', $v);

			$cal->modrecordstate(array(
			  'id'		=> $arr[0],
			  'shared'	=> $arr[1],
			  'Type'	=> $var['Type'])
			);
		}
	}

    $h = $cal->gettask( "", "", "", "all" );    // Get a hash containing the tasks
	//var_dump($h);
    // Foreach record, find the Title/ID
    foreach ( $h as $k=>$v)
	{
        $var['id']    = $v['id'];
        $var['title'] = ($v['Title'])? $v['Title'] : 'No Title';

        $var['due'] = $v['DateEnd'];
		$var['Shared'] = $v['Shared'];

		if ($var['due'] == "1970-01-01 00:00:00")
			$var['due'] = "No Due Date";
		else
			$var['due'] = $cal->duedate( $var['due'], time() );

        if ( strlen($var['title']) > 35 )
			$var['title'] = substr($var['title'], 0, 35);

		$var['typelist'] = $atmail->buildtype();

        $var['typelist'] = str_replace('<OPTION value="Complete">', '<OPTION value="Complete" selected>', $var['typelist']);

        // Append to our group tasks table
        $var['tasks'] .= $atmail->parse( "html/$atmail->Language/calendar/task.html", $var );
    }

    // Print the final results, containing a list of tasks
	print $atmail->parse( "html/$atmail->Language/calendar/todo.html", $var );
}


// Add a new calendar entry
function addtask()
{
	global $atmail, $param, $var, $cal;

    $var['Msg_Title']	= $param['Msg_Title'];
    $var['Msg_Text']	= $param['Msg_Text'];
    $var['Msg_Type']	= $param['Msg_Type'];

    $var['date']	= $param['date'];
	$var['enddate'] = $param['enddate'];
    $var['hour']	= $param['hour'];
    $var['minute']	= $param['minute'];

    $var['duedate']   = $param['duedate'];
    $var['duehour']   = $param['duehour'];
    $var['dueminute'] = $param['dueminute'];

	if ($cal->check_dates($var['date'], $var['hour'], $var['minute'], $var['duedate'], $var['duehour'], $var['dueminute']))
	{
		$var['enddate'] = $var['date'];
		$var['endhour'] = $var['hour'];
		$var['endminute'] = $var['minute'];
	}

    // Load the permission, find who can edit the post.
    $var['Notify'] = $param['Notify'];

	// Escape the <> chars
	list($var['Msg_Text'], $var['Msg_Title']) = str_replace(array('<', '>'), array('&lt;', '&gt'), array($var['Msg_Text'], $var['Msg_Title']));

	$var['Ref'] = $cal->addrecord(array(
		  'Task' => '1',
          'UserTo'     => "$atmail->username@$atmail->pop3host",
          'UserFrom'   => "$atmail->username@$atmail->pop3host",
          'Title'      => $var['Msg_Title'],
          'CalMessage' => $var['Msg_Text'],
          'Importance' => '1',
          'Type'       => $var['Msg_Type'],
          'Alert'      => '',
          'DateStart'  => "{$var['date']} {$var['hour']}:{$var['minute']}:00",
          'DateEnd'    => "{$var['enddate']} {$var['duehour']}:{$var['dueminute']}:00",
		  'ReadSelectedUsers' => $var['ReadSelectedUsers'],
		  'WriteSelectedUsers' => $var['WriteSelectedUsers'],
		  'WriteSelectedGroups' => $var['WriteSelectedGroups'],
		  'ReadSelectedGroups' => $var['ReadSelectedGroups'],
          'Permission' => '1')    // We are always allowed to edit our post
        );

    if ( $var['start_page'] )
        $var['extra'] = 'href="util.php?func=start" target="emailwin"';

    else
        $var['extra'] = 'href="task.php?func=todo&Refresh=1" target="bottomFrame"';

    print $atmail->parse("html/$atmail->Language/calendar/notify-taskadd.html", $var );
}


// Make a new calendar entry
function newtask()
{
	global $atmail, $var;

    $var['date'] = strftime("%Y-%m-%e ");
    $var['date'] = str_replace(' ', '', $var['date']); // Take away any spaces

    $var['startdate'] = strftime( "%Y-%m-%e", time() + 86400  );
    $var['startdate'] = str_replace(' ', '', $var['startdate']);    // Take away any spaces

    $var['time'] = strftime("%T");
    preg_match('/(\d+):(\d+):(\d+)/', $var['time'], $m);

    $var['hour']   = $m[1];
    $var['minute'] = $m[2];

    $var['minutelist'] = buildmin();
    $var['hourlist']   = buildhour();

    if ( $var['hour'] < 10 )
		$var['hour'] = "0{$var['hour']}";

    $var['minutelist'] = str_replace("<OPTION value='{$var['minute']}'>{$var['minute']}", "<OPTION value='{$var['minute']}' selected>{$var['minute']}", $var['minutelist']);
    $var['hourlist']   = str_replace("<OPTION value='{$var['hour']}'>{$var['hour']}", "<OPTION value='{$var['hour']}' selected>{$var['hour']}", $var['hourlist']);

    $var['duehourlist'] = $var['hourlist'];
    $var['duehourlist'] = preg_replace("/name='.*?'/", "name='duehour'", $var['duehourlist']);

    $var['dueminutelist'] = $var['minutelist'];
    $var['dueminutelist'] = preg_replace("/name='.*?'/", "name='dueminute'", $var['dueminutelist']);

	$var['typelist'] = $atmail->buildtype();

	if ($atmail->LoginType == "xp")
	    print $atmail->parse( "html/$atmail->Language/$atmail->LoginType/calendar/newtask.html", $var );
	else
		print $atmail->parse( "html/$atmail->Language/calendar/newtask.html", $var );
}

// Read a calendar entry
function readtask()
{
	global $atmail, $cal, $var, $param;

	//if ($var['start_page'])
	//output_add_rewrite_var('start_page', '1');

	$var['id'] = $param['id'];
    $style = $var['atmailstyle'];

    $var = array_merge($var, $cal->readpost( $var['id'], $param['shared'] ));

	$var['shared'] = $param['shared'];
    $var['type'] = $param['type'];

	$var['typelist'] = $atmail->buildtype();

	$var['typelist'] = preg_replace("/<OPTION VALUE=\"({$var['Type']})\">(.*)/i", '<OPTION VALUE="$1" selected>$2', $var['typelist']);

    // Loop through the Date entrys
    foreach ( array('DateStart', 'DateEnd') as $type )
	{
        preg_match('/(\d+)-(\d+)-(\d+) (\d\d):(\d\d):(\d\d)/', $var[$type], $m);

        $var['year']   = $m[1];
        $var['month']  = $m[2];
        $var['day']    = $m[3];
        $var['hour']   = $m[4];
        $var['minute'] = $m[5];

        $a = $type . "minutelist";
        $b = $type . "hourlist";

        $var[$a] = buildmin();
        $var[$b] = buildhour();

        $var[$a] = preg_replace("/name='(minute)'/", "name='$type\$1'", $var[$a]);
        $var[$b] = preg_replace("/name='(hour)'/", "name='$type\$1'", $var[$b]);

        $var[$a] = str_replace("<OPTION value='{$var['minute']}'>{$var['minute']}", "<OPTION value='{$var['minute']}' selected>{$var['minute']}", $var[$a]);
        $var[$b] = str_replace("<OPTION value='{$var['hour']}'>{$var['hour']}", "<OPTION value='{$var['hour']}' selected>{$var['hour']}", $var[$b]);

        $var[$type] = "{$var['year']}-{$var['month']}-{$var['day']}";
		if ($var[$type] == "1970-01-01")
			$var[$type] = "No Due Date";
    }

	if ($var['Permissions'] == 0)
		$var['Disabled'] = "disabled title='Read only access'";

	$var['atmailstyle'] = $style;
	$var['domid'] = $_REQUEST['domid'];
	$var['zoom_id'] = $_REQUEST['zoom_id'];

	if ($atmail->LoginType == 'xp' || $atmail->Ajax || $atmail->LoginType == 'simple')
		print $atmail->parse("html/$atmail->Language/xp/calendar/readtask.html", $var );
	else
		print $atmail->parse("html/$atmail->Language/calendar/readtask.html", $var );
}

// Modify a calendar entry
function updatetask()
{
	global $atmail, $cal, $var, $param;

    $var['id']         = $param['id'];
    $var['Title']      = $param['Msg_Title'];
    $var['CalMessage'] = $param['Msg_Text'];
    $var['Type']       = $param['Msg_Type'];

    $var['DateStarthour']   = $param['DateStarthour'];
    $var['DateStartminute'] = $param['DateStartminute'];
    $var['DateEndhour']     = $param['DateEndhour'];
    $var['DateEndminute']   = $param['DateEndminute'];

    // Fetch both the Start and End date
    $var['DateStart'] = $param['DateStart'];

	if ($var['DateStart'] == "No Due Date")
		$var['DateStart'] = "1970-01-01 00:00:00";
	else
		$var['DateStart'] .= " {$var['DateStarthour']}:{$var['DateStartminute']}:00";

	$var['DateEnd'] = $param['DateEnd'];

	if ($var['DateEnd'] == "No Due Date")
		$var['DateEnd'] = "1970-01-01 00:00:00";
	else
		$var['DateEnd'] .= " {$var['DateEndhour']}:{$var['DateEndminute']}:00";

    // Escape the <> chars
	list($var['CalMessage'], $var['Title']) = str_replace(array('<', '>'), array('&lt;', '&gt'), array($var['CalMessage'], $var['Title']));

    // Modify a record
    $cal->modrecord(array(
      'id'     => $var['id'],
      'UserTo'     => "$atmail->username@$atmail->pop3host",
      'UserFrom'   => "$atmail->username@$atmail->pop3host",
      'Title'      => $var['Title'],
      'Type'       => $var['Type'],
      'CalMessage' => $var['CalMessage'],
      'DateStart'  => $var['DateStart'],
      'DateEnd'    => $var['DateEnd'],
	  'ReadSelectedUsers' => $var['ReadSelectedUsers'],
	  'WriteSelectedUsers' => $var['WriteSelectedUsers'],
	  'WriteSelectedGroups' => $var['WriteSelectedGroups'],
	  'ReadSelectedGroups' => $var['ReadSelectedGroups'],
	  'Task' => '1')
    );

	$var['domid'] = $_REQUEST['domid'];

    print $atmail->parse("html/$atmail->Language/calendar/notify-taskmodify.html", $var );
}

// Delete a calendar entry
function deletetask()
{
	global $atmail, $cal, $var, $param;

    $var['id'] = $param['id'];
    $cal->delrecord( $var['id'], $var['username'], $param['shared'] );

    print $atmail->parse("html/$atmail->Language/calendar/notify-taskdelete.html", $var );
}

// Build a select box with each hour
function buildhour()
{
    $list = "<select name='hour' class='select'>";
    for ($hour = 1; $hour < 24; $hour++)
	{
        if ( $hour < 10 )
			$hour = "0$hour";

        $list .= "<OPTION value='$hour'>$hour</OPTION>";
    }

    $list .= "</select>";
    return $list;
}

// Build a select box with each minute
function buildmin()
{
    $list = "<select name='minute' class='select'>";

	for ($min = 0; $min < 60; $min++)
	{
        if ($min < 10)
			$min = "0$min";
        $list .= "<OPTION value='$min'>$min</OPTION>";
    }

    $list .= "</select>";

    return $list;
}

?>