<?php
// +----------------------------------------------------------------+
// | util.php														|
// +----------------------------------------------------------------+
// | Function: Folder Manager - View/Modify/Delete account folders  |
// | Used to view and save account preferences/settings				|
// +----------------------------------------------------------------+
// | Source-code (C) CalaCode.com 1998-2005 . All rights reserved	|
// | See http://calacode.com/license.ehtml for license agreement	|
// +----------------------------------------------------------------+
// | Date: Febuary 2005												|
// +----------------------------------------------------------------+

require_once('header.php');

require_once('Session.php');
require_once('Global.php');
require_once('GetMail.php');
require_once('Filters.php');
require_once('Language.php');

session_start();

// get the requested function
$var['func'] = $_REQUEST['func'];
$func = "util_{$var['func']}";

if (!function_exists($func)) {
	$func = str_replace("<", "&lt;", $func);
	$func = str_replace(">", "&gt;", $func);
	die("requested function '$func' does not exist");
}

$atmail = new AtmailGlobal();
$auth =& $atmail->getAuthObj();

$var = array();

$atmail->status = $auth->getuser( $atmail->SessionID );

$atmail->username = $auth->username;
$atmail->pop3host = $auth->pop3host;

// Print the error screen if the account has auth errors, or session timeout.
if ( $atmail->status == 1 )
	$atmail->auth_error();
if ( $atmail->status == 2 )
	$atmail->session_error();

// Load the account preferences
$atmail->loadprefs(1);

// If using the XUL interface, toggle to use the XP HTML templates
if ($atmail->LoginType == 'xul')
{
	$atmail->LoginType = 'xp';
	if (!$var['func'])
		$var['func'] = 'start';
}

if ($var['func'] != 'rename' && $var['func'] != 'delfolderxp')
	$atmail->httpheaders();

$var['languagebox'] = $atmail->languages(2);
$var['languagebox'] = str_replace("value='$atmail->Language'", "value='$atmail->Language' selected", $var['languagebox']);
$var['languagebox'] = str_replace("<select", "<select class=\"select\"", $var['languagebox']);

$mail = new GetMail(array(
  'Username' => $atmail->username,
  'Pop3host' => $atmail->pop3host,
  'Password' => $auth->password,
  'Mode'     => $atmail->Mode,
  'Type'     => $atmail->MailType)
);

// Disable EmailToFolder rules for POP3 - Not implemented until UIDL support
if($mail->MailType == 'pop3')
$pref['allow_EmailToFolderRules'] = 0;

$var['atmailstyle'] = $atmail->parse( "html/$atmail->Language/$atmail->LoginType/atmailstyle.css" );
$var['atmailstyle'] .= $atmail->parse("html/$atmail->Language/$atmail->LoginType/atmailstyle-form.css");

// now call the requested function
$func();

$atmail->end();


function util_demo()
{
	global $atmail, $reg;

    $var['expire'] = $reg['expiry'] - time();
    $var['expire'] = $var['expire'] / 86400;
    $var['expire'] = preg_replace('/\..*/', '', $var['expire']);

    if ( $var['expire'] == "0" )
        $var['expire'] = "Today";
    elseif ( $reg['expiry'] == "never" )
        $var['expire'] = "Never";
    else
        $var['expire'] = "in {$var['expire']} days";

	foreach( array('/etc/SuSE-release', '/etc/redhat-release', '/etc/fedora-release', '/etc/slackware-release', '/etc/debian_release', ' 	/etc/mandrake-release', '/etc/yellowdog-release', '/etc/sun-release', '/etc/release', '/etc/gentoo-release', '/etc/UnitedLinux-release') as $version)
	{
		if (!file_exists($version)) continue;
		$var['os'] = file_get_contents($version);
		$var['os'] = str_replace(array('"', "'", '<', '>', "\n", "\r"), '', $var['os']);
		break;
	}

		$var['os'] = trim($var['os']);

	if(empty($var['os']))
		$var['os'] = php_uname('s');

	if (file_exists('.rpminstall'))
		$var['rpm'] = '1';

    print $atmail->parse('html/demo.html', $var);
    $atmail->end();
}

// Print the attachment window
function util_show()
{
	global $mail, $atmail, $var;

    $mail->login();

    $folders = $mail->listfolders();

	// Create a new folder-tree element
	$mail->newfolder_tree();

	$var['SentMsgs'] = $var['InboxMsgs'] = $var['DraftsMsgs'] = $var['SpamMsgs'] = 0;

	// Disable new msg count till phase2
	//list($var['InboxMsgs'],) = $mail->showunread('INBOX');

	// Loop through each of the folders
    foreach ($folders as $folder)
    {
		if ($folder == 'Sent') {
			//list($var['SentMsgs'],) = $mail->showunread($folder);
			//$var['SentMsgs'] = 0;intval($var['SentMsgs']);
			continue;
		}

		// Mask the existing Trash folder, as the copy we want as defined via the Webadmin
		if ($folder == 'Trash') {
			//list($var['TrashMsgs'],) = $mail->showunread($folder);
			//$var['TrashMsgs'] = intval($var['TrashMsgs']);
			continue;
		}

		// Mask the existing Trash folder, as the copy we want as defined via the Webadmin
		if ($folder == 'Spam') {
			//list($var['SpamMsgs'],) = $mail->showunread($folder);
			//$var['SpamMsgs'] = intval($var['SpamMsgs']);
			continue;
		}

		// Mask the existing Trash folder, as the copy we want as defined via the Webadmin
		if ($folder == 'Drafts') {
			//list($var['DraftsMsgs'],) = $mail->showunread($folder);
			//$var['DraftsMsgs'] = intval($var['DraftsMsgs']);
			continue;
		}

		$var['xulfolder'] .= "myArray.push('$folder');\n";

		// Skip any sub-folders, we only want the base folders
		if ( strpos($folder, $mail->Deliminator) !== false )
			continue;

		// Append the folders to the $var['folders'] element to display in the template
		// Disable new msg count till phase2
		//$var['folders'] .= $mail->folder_depth($folder, $start, $folders, true, true);
		$var['folders'] .= $mail->folder_depth($folder, 'fld2', $folders, true, false);
    }

	// Take out
	$var['xulfolder'] = preg_replace('/,$/', '', $var['xulfolder']);

    echo $atmail->parse( "html/$atmail->Language/myfolders.js", $var );
}

function util_rename()
{
	global $mail, $atmail;

	$mail->login();

	$newfolder = $_REQUEST['NewFolder'];
	$newfolder = str_replace('\\', '', $newfolder);

	// Rename the specified mailbox
	// We are only passed the new folders name and not its
	// full path so we need to create the full path so that it
	// is not just renamed to INBOX.newfoldername
	$del = preg_quote($mail->Deliminator, '/');
	$newfolder = preg_replace("/[^{$del}]+$/", $newfolder, $_REQUEST['Folder']);
    $mail->renamefolder($_REQUEST['Folder'], $newfolder);

	// Delete any message filters that match the foldername
	$sort_subject = $atmail->getsort('EmailSubject','hash' );
	foreach ($sort_subject as $k => $v)
	{
		if ($v == $_REQUEST['Folder'])
		{
			$atmail->delsort($k,'EmailSubject');
			$atmail->addsort('', $k, $newfolder);
		}
	}

	$sort_email   = $atmail->getsort('EmailAddress','hash' );
	foreach ($sort_email as $k =>$v)
	{
		if ($v == $_REQUEST['Folder'])
		{
			$atmail->delsort($k,'EmailAddress');
			$atmail->addsort($k,'', $newfolder);
		}
	}

	header("Location: html/$atmail->Language/$atmail->LoginType/heading/mboxhead.html");
	$atmail->end();
}

function  util_delfolderxp()
{
	global $mail, $atmail;

	$mail->login();
	$del = $_REQUEST['delete'];

	$mail->delfolder( $del );

	if ($del != 'Trash' && $del != 'Spam')
	{
		// Delete any message filters that match the foldername
		$sort_subject = $atmail->getsort( 'EmailSubject', 'hash' );
		foreach ($sort_subject as $k => $v)
		{
			if ($v == $del)
				$atmail->delsort($k, 'EmailSubject');
		}

		$sort_email = $atmail->getsort( 'EmailAddress', 'hash' );
		foreach ($sort_email as $k => $v)
		{
			if ($v == $del)
				$atmail->delsort($k, 'EmailAddress');
		}
	}

	header("Location: html/$atmail->Language/$atmail->LoginType/heading/mboxhead.html");
	$atmail->end();
}

function util_newfolderxp()
{
	global $mail, $atmail, $var;

	$mail->login();
    $folders = $mail->listfolders();

	// Create a new folder-tree element
	$mail->newfolder_tree();

	// Loop through each of the folders
    foreach ($folders as $folder)
    {
		// Skip any sub-folders, we only want the base folders
		if ( strpos($folder, $mail->Deliminator) !== false)
			continue;

		// Append the folders to the $var['folders'] element to display in the template
		$var['folders'] .= $mail->folder_depth($folder, 'fld2', $folders, false);
    }

	$var['DefaultFolder'] = $_REQUEST['DefaultFolder'];
	$var['Type'] = $_REQUEST['Type'];

	print $atmail->parse("html/$atmail->Language/$atmail->LoginType/newfoldermodal.html", $var);
	$atmail->end();
}

function util_addfolderxp()
{
	global $mail, $atmail, $var;

	// Add a folder using the 'Advanced' interface - Optional Subfolder
	$mail->login();
	$var['FolderName'] = $_REQUEST['FolderName'];
	$var['SubFolder'] = $_REQUEST['SubFolder'];

	$mail->newfolder( $var['FolderName'], $var['SubFolder'] );


	if($atmail->XUL)	{
		if (!$_REQUEST['Type'])
			print "<html><body onload=\"top.mailhead.location.reload();\"></body></html>";
		else
			print "<html><body onload=\"top.mailhead.location.reload(); location.href='util.php?func=info';\"></body></html>";
	}

	elseif ($atmail->LoginType == 'xp')
	{
		if (!$_REQUEST['Type'])
			print "<html><body onload='top.FramePage.mailhead.location.reload();'></body></html>";
		else
			print "<html><body onload=\"top.FramePage.mailhead.location.reload(); location.href='util.php?func=info'\"></body></html>";
	}
	else
		print "<html><body onload='top.mailhead.location.reload();'></body></html>";

	$atmail->end();
}

function util_new()
{
    #	$var['foldername'] = $_REQUEST['folder'];
    #	$mail->newfolder($var['foldername']);
    #	print "Created new $var['foldername'] folder<BR>";
}

function util_info()
{
	global $mail, $atmail, $var, $domains;

    $mail->login();
	$reload = false;

	// We keep the folder info in session to speed up page loading as
    // when we have large folders this can take a while. Data stays valid
    // for 15 minutes
    //if (isset($_SESSION['folderinfo']) && ($_SESSION['folderinfo']['created'] < (time() - 900))) {
    //	unset($_SESSION['folderinfo']);
    //}

	if (isset($_REQUEST['renamefolder']) && !empty($_REQUEST['curname']) && !empty($_REQUEST['foldername'])) {
		if ($_REQUEST['curname'] != 'Sent' && $_REQUEST['curname'] != 'Trash' &&
		    $_REQUEST['curname'] != 'Drafts' && $_REQUEST['curname'] != 'Spam') {
			$new_folder = $_REQUEST['foldername'];
			$mail->renamefolder(str_replace('/', $mail->Deliminator, $_REQUEST['curname']),
			                    str_replace('/', $mail->Deliminator, $new_folder));
			$reload = true;
			//$_SESSION['folderinfo'][$new_folder] = $_SESSION['folderinfo'][$_REQUEST['curname']];
			//unset($_SESSION['folderinfo'][$_REQUEST['curname']]);
		}
	}

    // The user selects to create a new mailbox
    if ( $_REQUEST['creatembox'] )
    {
		$folder = $_REQUEST['foldername'];
        $mail->newfolder($folder);

        // Add the folder to the session data if required
        //if (isset($_SESSION['folderinfo']) && !preg_match('^(inbox|spam|trash|drafts|sent)$/i', $folder)) {
        //	$_SESSION['folderinfo'][$folder]['msgs'] = 0;
        //	$_SESSION['folderinfo'][$folder]['size'] = 0;
		//}

		$reload = true;
    }

    // A folder is set to delete
    elseif ( $_REQUEST['delete'] )
    {
		$del = $_REQUEST['delete'];
		if ($_REQUEST['purge'] == 1) {
			$mail->purgefolder($del);	
		} else {
			$mail->delfolder($del);
		}

        // Update the folder data in the session if required
        //if (isset($_SESSION['folderinfo']) && preg_match('/^(inbox|spam|trash|drafts|sent)$/i', $del)) {
        //	$_SESSION['folderinfo'][$del]['msgs'] = 0;
        //	$_SESSION['folderinfo'][$del]['size'] = 0;
		//} elseif (isset($_SESSION['folderinfo'])) {
        //	unset($_SESSION['folderinfo'][$del]);
        //	unset($_SESSION['folderinfo'][$del]);
		//}


		if ($del != 'Trash' && $del != 'Spam')
		{
			// Delete any message filters that match the foldername
			$sort_subject = $atmail->getsort( 'EmailSubject', 'hash' );
			foreach ($sort_subject as $k => $v)
			{
				if ($v == $del)
					$atmail->delsort($k, 'EmailSubject') ;
			}

			$sort_email   = $atmail->getsort( 'EmailAddress', 'hash' );
			foreach ($sort_email as $k => $v)
			{
				if ($v == $del)
					$atmail->delsort($k, 'EmailAddress');
			}
		}
		$reload = true;
    }

    // Add a new Email to the Spam List
    elseif ( $_REQUEST['spamadd'] )
        $atmail->addspamer();

    // Delete an address from the SpamList
    elseif ( $_REQUEST['spamdel'] )
        $atmail->delspamer();

    // The user is setting an autoreply . Either adding or deleting
    elseif ( $_REQUEST['addreply'] || $_REQUEST['deletereply'] )
    {
        if ( $_REQUEST['addreply'] )
        	$atmail->AutoReply = $_REQUEST['AutoReply'];
        elseif ( $_REQUEST['deletereply'] )
        	$atmail->AutoReply = '';

        $atmail->saveautoreply( $atmail->AutoReply );
    }

    // Add a new rule to the mail filters
    elseif ( $_REQUEST['addsort'] )
        $atmail->addsort();

    elseif ( $_REQUEST['delsort'] )
        $atmail->delsort( $_REQUEST['delete_sort'], $_REQUEST['type'] );

    // Find the folder names , size and number of messages
    $folders = $mail->listfolders();


	// sort the folders by name
	$folders = GetMail::_sort_folders($folders);

    // Make a select box with the foldernames
    $var['folderbox'] = $var['renamefolderbox'] = $mail->folder_select( 'Inbox', $folders, false);

    // Remove System folders from rename options
    $patterns = array("<option value=\"Trash\">Trash</option>",
                      "<option value=\"Spam\">Spam</option>",
                      "<option value=\"Drafts\">Drafts</option>",
                      "<option value=\"Sent\">Sent</option>");
    $var['renamefolderbox'] = str_replace($patterns, '', $var['renamefolderbox']);
    $var['renamefolderbox'] = '<option value="">--</option>' . $var['renamefolderbox'];

	$var['folderbox'] = str_replace("value=\"Trash\"", "value=\"Trash\" selected", $var['folderbox']);
	//$var['folderbox'] = preg_replace('/<option value="erase">.*?<\/option>/', '', $var['folderbox']);
	//$var['folderbox'] = preg_replace('/<option value="" style=\'color: gray;\'>.*?<\/option>/', '', $var['folderbox']);

	// Translate the mailbox folders into another language
	$var['folderbox'] = Language::folder_language( $var['folderbox'], $atmail->Language, null);

	list($var['usedquota'], $var['totalquota']) = $mail->getquota();

    // The size of our quota in Kb
	if (!$var['totalquota'])
	{
		$var['totalquota'] = $atmail->UserQuota;
		$var['totalquota'] = sprintf("%2.0f", $var['totalquota']);
	}

	if ($var['usedquota'] > 0 && $var['totalquota'] > 0)
	{
		$var['used'] = ( $var['usedquota'] / $var['totalquota']) * 100;

		if ($var['used'] < 1)
			$var['used'] = '1%';
		else
			$var['used'] = round($var['used'], 2) . '%';
	}

	$var['used_percent'] = $var['used']? $var['used'] : '1%';

    foreach ($folders as $folder)
    {
        // Retrieve the foldername without any / extension
		$folderlink = $mail->folder_getlink($folder);

        list( $num, $size ) = $mail->sizefolder($folderlink);

		// Get the data from the session if it exists
		//if (isset($_SESSION['folderinfo'][$folder]) && $_SESSION['folderinfo'][$folder]['msgs'] > 0) {
		//	$num = $_SESSION['folderinfo'][$folder]['msgs'];
		//	$size = $_SESSION['folderinfo'][$folder]['size'];
		//} else {
		// Implement cache function soon - Read the size for the moment
        //	list( $num, $size ) = $mail->sizefolder($folderlink);
        //	$_SESSION['folderinfo'][$folder] = array('msgs' => $num, 'size' => $size);
        //	$_SESSION['folderinfo']['created'] = time();
		//}

		// Skip Inbox for the POP3 protocol
        if ( strtoupper($folder) == 'INBOX' && !$domains[$atmail->pop3host] && $atmail->MailType == 'pop3' )
        	continue;

        // Change the display language, depending on the user language login
        $foldername = Language::folder_language( $folder, $atmail->Language, 1 );
        
        $var['folders'] .= $atmail->parse("html/$atmail->Language/$atmail->LoginType/foldertr.html", array(
          'Folder'     => $folder,
		  'FolderLink' => $folderlink,
          'FolderName' => $foldername,
          'Size'       => $size,
          'MsgNum'     => $num,
          'SystemFolder' => $mail->isAtmailFolder($folder)
        ));
    }

    // Make a select box with our list of spammers
    $var['spam_select'] = $atmail->spam_select();
    $var['sort_email']  = $atmail->getsort('EmailAddress');
    $var['sort_subj']   = $atmail->getsort('EmailSubject');


	// Translate the mailbox folders into another language
	$var['sort_email'] = $mail->folder_select_lang( $var['sort_email'], $atmail->Language, 1 );
	$var['sort_subj'] = $mail->folder_select_lang( $var['sort_subj'], $atmail->Language, 1 );


	$var['reloadFolders'] = (isset($_REQUEST['noreload']) || $reload == false) ? 'false' : 'true';

    print $atmail->parse( "html/$atmail->Language/$atmail->LoginType/folders.html", $var );
}

function util_settings()
{
	global $pref, $atmail, $var;

    if ( isset($_POST['save']) )
    {
		$previnterface = $atmail->LoginType;
		$prevlanguage = $atmail->Language;

		$atmail->savesettings();
		$atmail->loadprefs();

		if ($previnterface == 'xp' && $atmail->XUL && $atmail->LoginType != 'simple')
		{
			// Mask the current interface is using the XUL theme
			$previnterface = 'xp';
			$atmail->LoginType = 'xp';
		}

		// If the user has toggled to change the interface, reload the entire frame, otherwise just load the new settings window
		if ($previnterface != $atmail->LoginType || $atmail->Language != $prevlanguage )
		{
			// Change the users color settings, if logging into the XP interface
			if ( $atmail->LoginType == 'xp' || $atmail->LoginType == 'xul' )
			{
			    $atmail->changecolor(array(
			      'PrimaryColor'   => "#EBE9E4",
			      'SecondaryColor' => "#F4F4F4",
			      'ThirdColor'     => "#FAFAFA",
			      'HeaderColor'    => "#F5F5F5",
			      'HeadColor'      => "#06082C",
			      'BgColor'        => "#F9F9F9",
			      'TextColor'      => "#06082C",
			      'TextHeadColor'  => "#303030",
			      'LinkColor'      => "#000000",
			      'VlinkColor'     => "#000033",
			      'OnColor'        => "#F3F3F3",
			      'OffColor'       => "#FFFFFF",
			      'SelectColor'    => "#E4EEF8",
			      'TopBg'          => "imgs/graygrad.gif"
			    ));

			}
			elseif( $atmail->LoginType == 'simple' || $atmail->LoginType == 'ajax')
			{
			    $atmail->changecolor(array(
			      'PrimaryColor'   => "#EBE9E4",
			      'SecondaryColor' => "#F8FBFD",
			      'ThirdColor'     => "#FAFAFA",
			      'HeaderColor'    => "#F5F5F5",
			      'HeadColor'      => "#06082C",
			      'BgColor'        => "#F9F9F9",
			      'TextColor'      => "#06082C",
			      'TextHeadColor'  => "#303030",
			      'LinkColor'      => "#000000",
			      'VlinkColor'     => "#000033",
			      'OnColor'        => "#F3F3F3",
			      'OffColor'       => "#FFFFFF",
			      'SelectColor'    => "#FAF7F7",
			      'TopBg'          => "imgs/graygrad.gif"
			    ));
			}

			if ($atmail->XUL && $atmail->LoginType == 'xp')
			{
				$refresh = <<<EOF
<script language="JavaScript">
window.parent.location.href='parse.php?file=html/$atmail->Language/xul/xullogin.html&frame=1&XUL=1';
</script>
EOF;

			}
			elseif ($atmail->LoginType == 'simple' && $atmail->Ajax)
			{
				$refresh = <<<EOF
<script language="JavaScript">
parent.parent.location.href='parse.php?file=html/$atmail->Language/simple/showmail_interface.html&ajax=1';
</script>
EOF;

			}
			elseif ($atmail->LoginType == 'xul')
			{
				$refresh = <<<EOF
<script language="JavaScript">
window.parent.location.href='parse.php?file=html/$atmail->Language/xul/xullogin.html&frame=1&XUL=1';
</script>
EOF;

			}
			else
			{
				$refresh = <<<EOF
<script language="JavaScript">
parent.parent.location.href='parse.php?file=html/$atmail->Language/$atmail->LoginType/$atmail->LoginType.html&frame=1';
</script>
EOF;
			}

			print $refresh;
			$atmail->end();
		}
    }
    // generate pgp key
	elseif ( isset($_REQUEST['pgpsave']) )
	{
		$atmail->savesettingspgp(
			array(
				'PKIenable' => $_REQUEST['PKIenable'],
				'PGPenable' => $_REQUEST['PGPenable'],
				'PGPsign'   => $_REQUEST['PGPsign'],
				'PGPappend' => $_REQUEST['PGPappend']
				)
		);

		$atmail->loadprefs();
		if ($atmail->XUL)
			$atmail->LoginType = 'xp';
	}

	// Load the users PGP key if required
	if ($atmail->PGPenable && file_exists($pref['gpg_path']))
	{
		require_once('PGP.php');

		$userWrkDir;

		if ($atmail->MailDir)
			$userWrkDir	= $atmail->MailDir;
		else
			$userWrkDir= $atmail->tmpdir;

		$ownFile = $atmail->tmpdir . ".ht$auth->SessionID";

		$pgp = new PGP( array('wrkDir' => "$userWrkDir/pgp", 'ownFile' => $ownFile) );

		$var['PGPkey'] = $pgp->readPublickey();
	}

	$var['Tab'] 		= $_REQUEST['Tab'];

    $settings = $atmail->parse( "html/$atmail->Language/$atmail->LoginType/settings.html", $var );

	#$settings =~ s/<option value="$atmail->UserLanguage"/<option value="$atmail->UserLanguage" selected/g;

    $settings = str_replace("<option value=\"$atmail->MboxOrder\"", "<option value=\"$atmail->MboxOrder\" selected", $settings);
    $settings = str_replace("<option value=\"$atmail->EmailHeaders\"", "<option value=\"$atmail->EmailHeaders\" selected", $settings);


    if ( $atmail->TimeZone != '' )
    {
		$tz = $atmail->TimeZone;
        $settings = str_replace("<option value=\"$tz\"", "<option value=\"$tz\" selected", $settings);
    }

    $settings = str_replace("<option value=\"$atmail->MsgNum\"", "<option value=\"$atmail->MsgNum\" selected", $settings);
    $settings = str_replace("<option value=\"$atmail->FontStyle\"", "<option value=\"$atmail->FontStyle\" selected", $settings);
    $settings = str_replace("<option name='Refresh' value=\"$atmail->Refresh\"", "<option name='Refresh' value=\"$atmail->Refresh\" selected", $settings);
    $settings = str_replace("<option name='DisplayImages' value=\"$atmail->DisplayImages\"", "<option name='DisplayImages' value=\"$atmail->DisplayImages\" selected", $settings);

	// If not using the Ajax interface, preselect the Logintype in the pulldown
	if(!$atmail->Ajax)
		$settings = str_replace("<option value=\"$atmail->LoginType\"", "<option value=\"$atmail->LoginType\" selected", $settings);

	$settings = str_replace("<option value=\"$atmail->Language\"", "<option value=\"$atmail->Language\" selected", $settings);
    $settings = str_replace("<option name='LeaveMsgs' value=\"$atmail->LeaveMsgs\">Yes", "<option value=\"$atmail->LeaveMsgs\" selected>Yes", $settings);
	$settings = str_replace("<option name='LeaveMsgs' value=\"$atmail->LeaveMsgs\">No", "<option value=\"$atmail->LeaveMsgs\" selected>No", $settings);
    $settings = str_replace("<option value=\"$atmail->TimeFormat\"", "<option value=\"$atmail->TimeFormat\" selected", $settings);
	$settings = str_replace("<option value=\"$atmail->DateFormat\"", "<option value=\"$atmail->DateFormat\" selected", $settings);
	$settings = str_replace("<option value=\"$atmail->EmailEncoding\"", "<option value=\"$atmail->EmailEncoding\" selected", $settings);

	if ( $atmail->EmptyTrash )
    	$settings = str_replace('name="EmptyTrash"', 'name="EmptyTrash" checked', $settings);

    if ( $atmail->HtmlEditor )
    	$settings = str_replace('name="HtmlEditor"', 'name="HtmlEditor" checked', $settings);

    if ( $atmail->NewWindow )
    	$settings = str_replace('name="NewWindow"', 'name="NewWindow" checked', $settings);

    if ( $atmail->AutoTrash )
    	$settings = str_replace('name="AutoTrash"', 'name="AutoTrash" checked', $settings);

    if ( $atmail->Advanced )
    	$settings = str_replace('name="Advanced"', 'name="Advanced" checked', $settings);

    if ( $atmail->PGPappend )
    	$settings = str_replace('name="PGPappend"', 'name="PGPappend" checked', $settings);

	if ( $atmail->PGPsign )
		$settings = str_replace('name="PGPsign"', 'name="PGPsign" checked', $settings);

	if ( $atmail->SMIMEencrypt );
		$settings = str_replace('name="SMIMEencrypt"', 'name="SMIMEencrypt" checked', $settings);

	if ( $atmail->SMIMEsign )
		$settings = str_replace('name="SMIMEsign"', 'name="SMIMEsign" checked', $settings);

	if ( $atmail->AutoComplete )
		$settings = str_replace('name="AutoComplete"', 'name="AutoComplete" checked', $settings);

	$settings = str_replace("<option value=\"$atmail->PGPenable\">PGP", "<option value=\"$atmail->PGPenable\" selected>PGP", $settings);
	$settings = str_replace("<option value=\"$atmail->PGPenable\">S/MIME", "<option value=\"$atmail->PGPenable\" selected>S/MIME", $settings);

	$settings = preg_replace("/<option value=\"$atmail->PKIenable\">(Enabled|Disabled)/", "<option value=\"$atmail->PKIenable\" selected>\$1", $settings);
	//$settings = str_replace("<option value=\"$atmail->PKIenable\">Disabled", "<option value=\"$atmail->PKIenable\" selected>Disabled", $settings);

	if ($refresh)
		print $refresh;
	else
		print $settings;
}


// About page for @Mail - Used in XP interface
function util_about()
{
	global $atmail, $var;
    print $atmail->parse("html/$atmail->Language/about.html", array('os' => PHP_OS, 'atmailstyle' => $var['atmailstyle']));
}

function util_profile()
{
	global $atmail, $var, $pref;

    if ( $_REQUEST['save'] )
    {
        $var['status'] = $atmail->parse("html/$atmail->Language/msg/updated.html");
        $atmail->saveprofile();
    }

    $user = $atmail->getprofile();

    $settings = $atmail->parse("html/$atmail->Language/$atmail->LoginType/profile.html", array_merge($user, $var));
    $settings = str_replace("<option value=\"{$user['Gender']}\"", "<option value=\"{$user['Gender']}\" selected", $settings);
    $settings = str_replace("<option value=\"{$user['Industry']}\"", "<option value=\"{$user['Industry']}\" selected", $settings);
    $settings = str_replace("<option value=\"{$user['Occupation']}\"", "<option value=\"{$user['Occupation']}\" selected", $settings);
    $settings = str_replace("<option value=\"{$user['Country']}\"", "<option value=\"{$user['Country']}\" selected", $settings);
    $settings = preg_replace("/name=\"BirthDay\"(.*?)<option value=\"{$user['BirthDay']}\"/", 'name="BirthDay" $1'." <option value=\"{$user['BirthDay']}\" selected", $settings);
    $settings = preg_replace("/name=\"BirthMonth\"(.*?)<option value=\"{$user['BirthMonth']}\"/", 'name="BirthMonth" $1'." <option value=\"{$user['BirthMonth']}\" selected", $settings);

    print $settings;
}

function util_password()
{
	global $atmail, $auth, $var, $pref;

    if ( $_REQUEST['save']) {
    	
    	if (!$pref['allow_UserChangePass'] || $pref['allow_Passutil']) {
        	$var['msg'] = $auth->changepass($_REQUEST['newpass'], $_REQUEST['oldpass'], 
        	                                $_REQUEST['PasswordQuestion'], $_REQUEST['newpass2']);
    	} else {
    		$var['msg'] = 3;//Language::getErrorMessage('change_pass_not_allowed', $atmail->Language);
    	}
    }

    print $atmail->parse("html/$atmail->Language/$atmail->LoginType/password.html", $var );
}

function util_logout()
{
	global $atmail, $mail;

    if ( $atmail->EmptyTrash )
    {
        $mail->delfolder('Trash');
    }
    print "<html><head></head><body><script language='javascript'> location.href='index.php?func=logout'</script></body></html>";
	$atmail->end();
}

function util_start()
{
	global $mail, $atmail, $var, $settings, $domains;

	output_add_rewrite_var('start_page', '1');

    require_once('Calendar.php');

    // List the tasks and Calander dates
    $cal = new Calendar(array(
      'username' => $atmail->username,
      'pop3host' => $atmail->pop3host,
      'userfrom' => $atmail->userfrom
    ));

    // Check if any tasks are being deleted
    $arr = $_REQUEST['id'];

	if (is_array($arr))
	{
		foreach ($arr as $v)
			$cal->delrecord( $v, $atmail->username );
	}

	$time = time();

    // Get the date
    $var['date'] = date('D M d'); //localtime();
    //$var['date'] = preg_replace('/(\d+):(\d+):(\d+) (\d+)/', '', $var['date']);

    setlocale(LC_TIME, $atmail->Language, 'en_US');
	$var['startdate'] = strftime("%A %d %B", $time);
	$var['startdate'] = iconv('iso-8859-1', "UTF-8", $var['startdate']);
    $mail->login();

    // List the folders, with their numbers of msgs and size
    $folders = $mail->listfolders();

    foreach ($folders as $folder)
    {
        // Skip the Inbox if we are not a local mailbox for pop3
        //if ( $folder == 'Inbox' && !$domains[$atmail->pop3host] && $atmail->MailType == 'pop3')
        //	continue;

		// Only listed specified folders
		if ( $folder != 'Inbox' && $folder != 'Sent' && $folder != 'Drafts' && $folder != 'Trash' && $folder != 'Spam')
			continue;

        list( $num, $size ) = $mail->sizefolder($folder);
		list( $unread, $total ) = $mail->showunread($folder);

        // Change the display language, depending on the user language login
        $foldername = $mail->folder_select_lang( $folder, $atmail->Language, 1 );

        $var['folders'] .= $atmail->parse("html/$atmail->Language/$atmail->LoginType/startfolder.html", array(
        	'Folder'     => $folder,
          	'FolderName' => $foldername,
          	'Size'       => $size,
          	'MsgNum'     => $num,
		  	'Unread'     => $unread
        ));
    }

    $h = $cal->gettask( '', '', '', 'all' );    // Get a hash containing the tasks

    // Foreach record, find the Title/ID
    foreach ($h as $v)
    {
        $var['id']    = $v['id'];
        $var['Title'] = ($v['Title'])? $v['Title'] : $atmail->parse("html/$atmail->Language/msg/notitle.html");

        if ( strlen( $var['title'] ) > 35 )
        	$var['Title'] = substr( $var['Title'], 0, 35 ) ;
        $var['Title'] = ucfirst( $var['Title'] );
		$var['Shared'] = $v['Shared'];

        // Append to our group tasks table
        $var['tasks'] .= $atmail->parse( "html/$atmail->Language/$atmail->LoginType/starttask.html", $var );
    }

    // Append the update button if we have tasks
    if ( $var['tasks'] && $atmail->LoginType != 'xp')
    	$var['tasks'] .= $atmail->parse( "html/$atmail->Language/$atmail->LoginType/startbutton.html", $var );

    // Display the empty screen otherwise
    if ( !$var['tasks'] )
    	$var['tasks'] .= $atmail->parse( "html/$atmail->Language/$atmail->LoginType/startnotask.html", $var );

    $var['month'] = ($_REQUEST['month'])? $_REQUEST['month'] : strftime( "%m", $time );
    $var['year']  = ($_REQUEST['year'])? $_REQUEST['year'] : strftime( "%Y", $time );
    $var['day']   = ($_REQUEST['day'])? $_REQUEST['day'] : strftime( "%e", $time );

    foreach ( array('day', 'year', 'month') as $v)
    {
        $var[$v] = str_replace(' ', '', $var[$v]);
        if ( strlen( $var[$v] ) == 1 )
        	$var[$v] = "0$var[$v]" ;
    }

    // Display the next Calendar entrys for the upcomming week
    $var['next'] = strtotime("+1 week");    # NOW => "$var['month']/$var['day']/$var['year']");
    $var['next'] = strftime( "%Y-%m-%e", $var['next'] );

    $h = $cal->getdate( "{$var['year']}-{$var['month']}-{$var['day']} 00:00:00", $var['next'] );

    // Loop through each Calendar entry
    foreach ($h as $k => $v)
    {
		// The ID is stored in the table, otherwise default to $id
        $var['id'] = ($v['id'])? $v['id'] : $k;
		if (!$var['id'])
			continue;

        $var['DateStart'] = $v['DateStart'];
        $var['Title']     = $v['Title'];
		if ( strlen( $var['title'] ) > 35 )
			$var['Title'] = substr( $var['Title'], 0, 35 );
        $var['Title'] = ucfirst( $var['Title'] );
		$var['Shared'] = $v['Shared'];
        $var['DateStart'] = preg_replace('/:\d\d$/', '', $var['DateStart']);
        $var['calendar'] .= $atmail->parse( "html/$atmail->Language/$atmail->LoginType/startcal.html", $var );
    }

     if ( !$var['calendar'] )
     	$var['calendar'] .= $atmail->parse( "html/$atmail->Language/$atmail->LoginType/startnocal.html", $var );

    if ( $_REQUEST['summary'] )
    {
        // Finally, print the start page for the user
        print $atmail->parse( "html/$atmail->Language/calendar/summary.html", $var );
    }
    else
    {
        // Print the default StartPage
		if ( !$atmail->LeaveMsgs && !$domains[$atmail->pop3host] )
        	$atmail->MailType = $atmail->Mode;

        if (true) {//$atmail->MailType == 'imap') {

            $mail->select('Inbox');

            if ($atmail->MailType == 'imap' || $atmail->MailType == 'pop3') {
            	$end = $mail->mailer->stat(0);
            } else {
            	list(,$end) = $mail->showunread_file('Inbox');
            }

            if ($end > 6)
                $start = $end - 6;
            else
                $start = 1;

            $results = $mail->getmailboxsummary($start, $end, 'INBOX', 1);
            $var['total'] = $end;
        } else {
            $results = $mail->msgid( 'Inbox', 'id', $var['order'] );
            $var['total'] = count($results);
        }


        $results = array_reverse($results);

        $var['num']   = $var['total'] - 6;

        // Open messages with the correct file using the XP interface
        if ( $atmail->LoginType == 'xp' )
        	$var['type'] = 'message' ;
        if ( $atmail->LoginType == 'simple' )
        	$var['type'] = '_parent' ;

		$count = 0;
		$id = $end;

        foreach ($results as $result)
        {
        	// If we are reading from the local Maildir folders or SQL tables
			if ($mail->Mode == 'file' || $mail->Type == 'sql') {
				$id = $result['id'];
			} elseif (isset($result['UID'])) {
			    $id = $result['UID'];
			}

            $count++;
            $db = $mail->message_headers($result['header'], $id);
            $db = $mail->clean_header( array_merge($db, array('TimeZone' => $atmail->TimeZone)) );
            $var['emails'] .= $atmail->parse( "html/$atmail->Language/$atmail->LoginType/startmbox.html", array_merge($db, array('type' => $var['type'], 'count' => $count)) );

        	$id--;
        }


        // Display there are no messages
        if ( !$var['emails'] )
        	$var['emails'] = $atmail->parse("html/$atmail->Language/$atmail->LoginType/startmboxempty.html");

        $logins = $atmail->db->sqlmultihash( "select * from Log_Login where Account='$atmail->username@$atmail->pop3host' Order by id desc limit 3");

        $var['totallogin'] = count($logins);

        foreach ($logins as $log)
        {
            //$db = $atmail->db->sqlhash("select * from Log_Login where id='$id'");
            $log['LogMsg'] = str_replace('Access from ', '', $log['LogMsg']);
            $log['LogDate'] = preg_replace('/\d\d:\d\d:\d\d$/', '', $log['LogDate']);
            $log['LogDate'] = strftime($atmail->DateFormat, strtotime($log['LogDate']));
            $var['logins'] .= $atmail->parse( "html/$atmail->Language/$atmail->LoginType/startlogin.html", $log );
        }

        // Find out if we are the startpage
        if ( $_REQUEST['spage'] )
        {
            $atmail->StartPage = $_REQUEST['StartPage'];
            $atmail->startpage();
        }

        if ( $atmail->StartPage )
        	$var['check'] = 'checked';

        // Check the user quota
        //$quota = $mail->getquota();
		list($var['usedquota'], $var['totalquota']) = $mail->getquota();

		if(!$var['totalquota'])
		{
			// The size of our quota in Kb
	        $var['totalquota'] = $atmail->UserQuota;
	        $var['totalquota'] = round($var['totalquota'], 1);
		}

		if ($var['totalquota'] > 0)
		{
	        $var['used'] = ( $var['usedquota'] / $var['totalquota'] ) * 100;
	        $var['used'] = round($var['used']) . '%';
	        if ( $var['used'] == "0%" )
	        	$var['used'] = "1%" ;
		}

		// Display the quota on the start page
		if($var['usedquota'] > 0 && $var['totalquota'] > 0)
		$var['quotasupport'] = 1;

        // Finally, print the start page for the user
        print $atmail->parse("html/$atmail->Language/$atmail->LoginType/startpage.html", $var );

    }
}

// The account functions for adding a new external account
function util_account()
{
	global $mail, $atmail, $var, $domains;

    // Check if we are deleting an account
    if ( $_REQUEST['del'] )
        $mail->delaccounts( $_REQUEST['del'], $_REQUEST['type']);

    // Create the new account in the SQL database
    if ( $_POST['Add'] )
    {
        if ($_POST['type'] == 'personality')
        {
            list($username, $host) = explode('@', $_POST['exusername']);
            $mail->addaccount(array(
              'MailType'   => 'pers',
    	      'Username'   => $username,
              'Pop3host'   => $host,
    		  'MailServer' => '',
              'Password'   => '')
    		);
        }
        else
        {
            $mail->addaccount(array(
              'MailType'   => $_REQUEST['MailType'],
    	      'Username'   => $_REQUEST['exusername'],
              'Pop3host'   => $_REQUEST['expop3host'],
    		  'MailServer' => $_REQUEST['exmailserver'],
              'Password'   => $_REQUEST['expassword'])
    		);
        }
    }

    $acct = $mail->showaccounts();
    $pers = $mail->showaccounts('personalities');

    foreach ($acct as $a)
    {
        list ($username, $var['Mailserver'], $var['Type']) = explode(":", $a);
        list ($var['Username'], $var['Pop3host'], $var['Pop3host2']) = explode('@', $username);

		if ($var['Pop3host2'])
			$username = preg_replace('/@[a-z\-0-9\.]+$/', '', $username);
        $pass = $mail->showaccounts($username);

        // Choose which method of delivery
        if ( !$domains[$var['Pop3host']] )
            $var['type'] = 'pop3';

        else
            $var['type'] = $atmail->Mode;

        // Get the number of messages on the server
        $mymail = new GetMail(array(
          'Username' => $var['Username'],
          'Pop3host' => $var['Pop3host'],
          'Password' => $pass,
          'Mode'     => $atmail->Mode,
          'Type'     => $var['type']
        ));

		if ($var['Pop3host2'])
			$mymail->MailAuth = 1;

		$res = $mymail->login();

        $results = $mymail->msgid( 'Inbox', 'id', $var['order'] );

        $var['MsgNum'] = $var['total'] = count($results);
        $var['acct'] .= $atmail->parse("html/$atmail->Language/accounts.html", $var);
    }

    foreach ($pers as $p)
        $var['personalities'] .= $atmail->parse("html/$atmail->Language/personalities.html", array('personality' => $p));

    print $atmail->parse( "html/$atmail->Language/$atmail->LoginType/account.html", $var );
}

function util_imapfolders()
{
	global $mail, $atmail, $var;

	$type = $_REQUEST['type'];
	$action = $_REQUEST['action'];
	$folder = $_REQUEST['FolderFilter'];
	$foldersub = $_REQUEST['FolderFilterSub'];

	// Subscribe to the selected mailboxes
	if ($action == 'add')
	{
		$id = $_REQUEST['id'];

		if (is_array($id))
		{
		  foreach ($id as $v)
		  {
			$mail->subscribe($v);
		  }
		}

	}

	// Unsubscribe the selected mailboxes
	if ($action == 'hide')
	{
		$id = $_REQUEST['id'];

		if (is_array($id))
		{
		  foreach ($id as $v)
		  {
		    $mail->unsubscribe($v);
		  }

		}

	}

	// If using the simple interface load the message folders into
	// a single table
	if ($atmail->LoginType == 'simple')
	{
		// List all the message folders from the server
		$folders = $mail->listfolders('' , 'list');

		// Print a row foreach record
		foreach ($folders as $fol)
		{
			if (!preg_match("/$folder/i", $fol) && $folder)
				continue;
			$var['imapfolders_all'] .= $atmail->parse("html/$atmail->Language/$atmail->LoginType/imapfolder_row.html", array('FolderName' => $fol));
		}

		// List the subscribed mailboxes
		$subscribe = $mail->listfolders('', '');

		// Print a row foreach record
		foreach ($subscribe as $sub)
		{
			if (!preg_match("/$foldersub/i", $sub) && $foldersub)
				continue;
			$var['imapfolders_subscribe'] .= $atmail->parse("html/$atmail->Language/$atmail->LoginType/imapfolder_row.html", array('FolderName' => $sub));
		}

		// Print the full table containing all the message folders
		print $atmail->parse("html/$atmail->Language/$atmail->LoginType/imapfolders.html", $var);

	}

	// List the message folders for the Professional/XP interface
	elseif ($type == 'list')
	{
		$var['lsub'] = $_REQUEST['lsub'];

		// Toggle which method to show the folders ; subscribed or all folders
		if ( $var['lsub'] )
			$folders = $mail->listfolders('');
		else
		{
			$folders = $mail->listfolders('' , 'list');
			//$subscribe = $mail->listfolders('', '');
		}

		// Open the iframe table
		print $atmail->parse("html/$atmail->Language/$atmail->LoginType/imapfolders_head.html", $var);

		// Print a row foreach record
		foreach ($folders as $fol)
		{
			if (!preg_match("/$foldersub/i", $fol) && $foldersub || !preg_match("/$folder/i", $fol) && $folder)
				continue;

			print $atmail->parse("html/$atmail->Language/$atmail->LoginType/imapfolder_row.html", array('FolderName' => $fol));
		}

		// Print the table footer
		print $atmail->parse("html/$atmail->Language/$atmail->LoginType/imapfolders_bottom.html", array('action' => $action) );

	}
	else
	{
		// Print the master imapfolders panel
		print $atmail->parse("html/$atmail->Language/$atmail->LoginType/imapfolders.html", $var);
	}

}

function util_pgpwait()
{
	global $atmail, $var, $pref;
	print $atmail->parse("html/$atmail->Language/xp/pgpwait.html", $var);
}

function util_genkey()
{
	global $atmail, $pref, $auth, $var;

	$keytype = $_REQUEST['PGPenable'];

	if ($keytype)
	{

		require_once('PGP.php');
		require_once('Abook.class.php');

		// Create a temporary directory to store PGP data
		if ($atmail->MailDir)
			$userWrkDir	= $atmail->MailDir;
		else
			$userWrkDir= $atmail->tmpdir;

		$ownFile = $atmail->tmpdir . ".ht$auth->SessionID";

		$pgp = new PGP( array('wrkDir' => "$userWrkDir/pgp", 'ownFile' => $ownFile) );

		// Generate the PGP key based on the users input
		$name = ($atmail->RealName)? $atmail->RealName : 'My account';
		$pgp->genKey($name, "$atmail->username@$atmail->pop3host", $_REQUEST['PGPpassword'], $_REQUEST['PGPsecurity'] );

		// Save the PGP settings to enable mail encryption
		$atmail->savesettingspgp(array('PGPenable' => 1));

		// Add the users PGP key into the addressbook
		$abook = new Abook( array('Account' => "$atmail->username@$atmail->pop3host") );
		$abook->updatepgp( array('UserEmail' => "$atmail->username@$atmail->pop3host", 'UserPgpKey' => $pgp->retrieveAsciiPub()) );

		// Remove the users session-id pgp password
		@unlink($atmail->tmpdir . ".ht$auth->SessionID");

		print $atmail->parse("html/$atmail->Language/$atmail->LoginType/pgpdone.html", $var);
	}
	else
	{
		if ($atmail->MailDir)
			$userWrkDir	= "$atmail->MailDir";
		else
			$userWrkDir= $atmail->tmpdir;

		$pass = $_REQUEST['PGPpassword'];
		$bits = $_REQUEST['PGPsecurity'];
		$city = $_REQUEST['SMIMEtown'];
		$state = $_REQUEST['SMIMEstate'];
		$country = $_REQUEST['SMIMEcountry'];

		$tf1 = tempnam($userWrkDir);
		$tf2 = tempnam($userWrkDir);
		// Need to validate unsafe exec, escape vars
		//$command = "openssl req -new -nodes -x509 -out $tf1 -keyout $tf2 -days 3650 -subj \"/C=$country/ST=$state/L=$city/CN=atmail/emailAddress=$atmail->username@$atmail->pop3host\" -passin pass:$pass -newkey rsa:$bits";
		//`$command`;
		// now get the contents (PEM) of the two key files and store them in the db.
		// return something or other.
	}

}


function util_spamsettings()
{
	global $atmail, $var, $mail, $pref;


	// Load selected vars for the function
	$var['Header']      = $_REQUEST['Header'];
	$var['Value']       = $_REQUEST['Value'];
	$var['Description'] = $_REQUEST['Description'];
	$var['Score']       = $_REQUEST['Score'];
	$var['Type']        = $_REQUEST['Type'];
	$var['Origin']      = $_REQUEST['Origin'] ? $_REQUEST['Origin'] : 'User';
	$var['Sort']        = $_REQUEST['Sort'] ? $_REQUEST['Sort'] : 'Value';
	$var['id']          = $_REQUEST['id'];
	$var['Add'] 		= $_REQUEST['Add'];
	$var['Filter'] 		= $_REQUEST['Filter'];
	$var['Tab'] 		= $_REQUEST['Tab'];

	// If the user is saving the setting, load the details and update the database
	if ( $_REQUEST['save'] )
	{
		$atmail->abook_trusted = $_REQUEST['abook_trusted'];
		$atmail->bayes_auto_learn = $_REQUEST['bayes_auto_learn'];
		$atmail->spam_treatment = $_REQUEST['spam_treatment'];
		$atmail->enable_av = $_REQUEST['enable_av'];
		$atmail->required_score = $_REQUEST['required_score'];
		$atmail->report_safe = $_REQUEST['report_safe'];
		$atmail->rewrite_header = $_REQUEST['rewrite_header'];
		$atmail->whitelist_only = $_REQUEST['whitelist_only'];

		if ($_REQUEST['bayes_auto_learn'])
			$atmail->bayes_path = "$mail->MailDir/bayes";

		$atmail->savespamsettings();
		$atmail->loadspamsettings();
	} else {
	    $atmail->loadspamsettings();
	}


	// Display an iframe with their results
	if ($var['Filter'])
	{
		$filter = new Filters(array('Account' => "$atmail->username@$atmail->pop3host"));

	    // Delete the selected filter
		if ( $_REQUEST['DeleteSelected'] )
		{
		    $ids = array();
			$ids = $_REQUEST['id'];

			// Loop through each entry in the array
			foreach ($ids as $id) {
				$filter->delentry(array('id' => $id));

			}

		}
		elseif ( $_REQUEST['Modify'] )
		{
	    	// Modify function

            $v = $filter->modentry(array(
              'Header'      => $var['Header'],
              'Value'       => $var['Value'],
              'Description' => $var['Description'],
              'Score'       => $var['Score'],
              'Type'        => $var['Type'],
              'Origin'     => $var['Origin'],
              'Account'     => "$atmail->username@$atmail->pop3host",
              'id'          => $var['id']
            ));

			$var['Added'] = 1;

			if ($v)
			{
				// Cleanup the regular expression for the Jscript error, and shorten the error message
				$v = preg_replace("/\n|\r|'|/", '', $v);
				$v = preg_replace('/(.*regex).*/', '$1', $v);

				print "<script>alert('Modification is an invalid regular expression: $v')</script>";
			}
	    }
	    elseif ( $var['Add'] )
	    {
			if ($var['Header'] == 'blacklist_from' )
			{
				preg_match('/<(.*?)>/', $var['Value'], $match);
				$var['Value'] = ($match[1])? $match[1] : $var['Value'];
			}

			// Add a new entry
	        $v = $filter->addentry(array(
	          'Header'      => $var['Header'],
	          'Value'       => $var['Value'],
	          'Description' => $var['Description'],
	          'Score'       => $var['Score'],
	          'Type'        => $var['Type'],
	          'Origin'      => $var['Origin'],
	          'Account'     => "$atmail->username@$atmail->pop3host"
	        ));

	    }
	    elseif ( $_REQUEST['Delete'] )
	    {
	    	//Delete a single entry
	        $filter->delentry( array('id' => $var['id']), "$atmail->username@$atmail->pop3host" );
	    }

		if( $_REQUEST['Refresh'] )
		{
			print "<script>location.href='util.php?func=spamsettings&Tab=2';</script>";
			$atmail->end();
		}

		if ( $_REQUEST['Display'] || $var['Filter'] )
		{
	        $type = $_REQUEST['Type'];
	        if (!$type)
	        	$type = 'Value';

	        if ( $type == 'Score' )
	        	$type = "$type desc";

	        $id = $filter->displayresults(array('preference' => $var['Header'], 'Sort' => $var['Sort']));

			// Create the form element that contains the entries
			$var['Filter'] = "parent.document.spam" . strtolower($var['Header']);

	        foreach ($id as $myid)
	        {
	            $db = $filter->returnfilter($myid);

	            $var['list'] .= $atmail->parse("html/$atmail->Language/filter_entry.html", array(
					'value' => $db['value'],
	              	'id'    => $myid)
	            );
	        }

	        print $atmail->parse( "html/$atmail->Language/filter_list.html", $var );
	    }

	} else {
		if (!isset($atmail->required_score))
			$atmail->required_score = $pref['filter_required_score'];
		if (!isset($atmail->bayes_auto_learn))
			$atmail->bayes_auto_learn = $pref['filter_use_bayes'];
		if (!isset($atmail->enable_av))
			$atmail->enable_av = $pref['virus_enable'];
		if (!isset($atmail->report_safe))
			$atmail->report_safe = $pref['filter_report_safe_enable'];
		if (!isset($atmail->rewrite_header))
			$atmail->rewrite_header = $pref['filter_subject_tag'];

		$var['spamsettings'] = $atmail->parse("html/$atmail->Language/$atmail->LoginType/spamsettings.html", $var);

		if ($atmail->abook_trusted)
			$var['spamsettings'] = preg_replace("<input type='checkbox' class='(.*?)' name='abook_trusted' value='1'>", "<input type='checkbox' class='\$1' name='abook_trusted' value='1' checked>", $var['spamsettings']);

		$var['spamsettings'] = str_replace("<option value=\"$atmail->spam_treatment\">", "<option value=\"$atmail->spam_treatment\" selected>", $var['spamsettings']);
		$var['spamsettings'] = str_replace("<option value=\"$atmail->required_score\">", "<option value=\"$atmail->required_score\" selected>", $var['spamsettings']);

		if ($atmail->enable_av)
			$var['spamsettings'] = str_replace("<input type='checkbox' class='text' name='enable_av' value='1'>", "<input type='checkbox' class='text' name='enable_av' value='1' checked>", $var['spamsettings']);
		if ($atmail->bayes_auto_learn)
			$var['spamsettings'] = preg_replace("/<input type='checkbox' class='(.*?)' name='bayes_auto_learn' value='1'>/", "<input type='checkbox' class='\$1' name='bayes_auto_learn' value='1' checked>", $var['spamsettings']);
		if ($atmail->report_safe)
			$var['spamsettings'] = str_replace("<input type='checkbox' class='text' name='report_safe' value='1'>", "<input type='checkbox' class='text' name='report_safe' value='1' checked>", $var['spamsettings']);
		if ($atmail->whitelist_only)
			$var['spamsettings'] = preg_replace("/<input type='checkbox' class='(.*?)' name='whitelist_only' value='1'>/", "<input type='checkbox' class='\$1' name='whitelist_only' value='1' checked>", $var['spamsettings']);

		// Display the page after selecting the default settings/checkboxes
		print $var['spamsettings'];
	}

}

// Logoff the mail server gracefully
$mail->quit();

?>
